<?php

// PENDING : a revoir

class BackModule {

    var $sql = null;
    // Caract豩stiques du module
    var $name;
    // module_nom : titre du module
    var $name_url;
    // module_page : url du module
    var $parent;
    // parent_module_titre : titre du module parent
    var $parent_url;
    var $orderBy;
    var $groupBy;
    var $page;
    var $limit;
    var $request;
    // Requete de selection
    // --
    // Elements du module
    var $miniForm = array();
    var $labels = array();
    var $forms = array();
    var $bases = array();
    //Base de donn裨s) ger裨s) par le module
    // --
    var $path = array();
    //Chemin haut (Gestion truc > edition truc|ajout truc etc..)
    var $urlForms;
    // Forms to Url
    var $sqlForms;
    // Forms to SQL
    var $droits = array();
    var $div = false; // AJAX

    /**
     * Liste des fichiers de la doc a afficher dans le panel de droite.
     * Possibilité de mettre le path d'un seul fichier
     * Ou un tableau avec le path de plusieurs fichiers, cela va générer des onglets dans la sidebar
     * @var null|string[]|string
     */
    var $docs = null;

    var $openSearch = true;

    public function __construct($formvars = array())
    {

        // Instance de la classe Site_SQL
        $this->sql = SiteSQL::getInstance();
        //--
        // $this->path[] = "<span><a href='" . BACK_URL . "'><img alt='home_btn' src='" . BACK_URL . "styles/images/tableau.png' /></a>&nbsp;</span>";
        $this->path[] = "<a href='" . BACK_URL . "'><i class='fa fa-dashboard'></i> Home</a>";

        // Réperation des caractéstiques du module
        @list($arrM) = $this->get($formvars);

        $this->name = $arrM['module_nom'];
        $this->name_url = $arrM['module_page'];
        $this->parent = $arrM['parent_module_titre'];
        $this->groupBy = $arrM['module_group'];
        if (!empty($formvars['order']))
            $this->orderBy = $formvars['order'];
        else
            $this->orderBy = $arrM['module_order'];

        if (!empty($_SESSION['limit'][$this->name_url]))
            $this->limit = $_SESSION['limit'][$this->name_url];
        else
            $this->limit = $arrM['module_limit'];

        if (!empty($formvars['page']))
            $this->page = $formvars['page'];
        else
            $this->page = 1;

        if (!empty($formvars['parent_url']))
            $this->parent_url = $formvars['parent_url'];

        if (!empty($formvars['div']))
            $this->div = $formvars['div'];
        else
            $this->div = false;

        if (strpos($arrM['module_bases'], '|') === false)
            array_push($this->bases, $arrM['module_bases']);
        else
            $this->bases = explode('|', $arrM['module_bases']);


        $this->path[] = "<a href='" . $this->link_to('cleanList') . "'>" . $this->name . "</a>";

        $droit = new BackDroit;
        $this->droits = $droit->get($this->name_url);
        //--
    }

    /**
     * @param string $idx : 'path' | 'query'
     * @return string
     */

    function getUrl($idx = 'path'){
        $arr = parse_url($_SERVER['REQUEST_URI']);
        return (!empty($arr[$idx])) ? $arr[$idx] : '';
    }

    function get($formvars=array(), $champs="") {

        $sql = "SELECT bm.module_id, bm.module_parent_id, bm.module_nom, bm.module_titre, bm.module_page, bm.module_rang, bm.actif_id, bm.module_order, bm.module_group, bm.module_limit, bm.module_bases, bmp.module_titre as parent_module_titre";
        $sql.=" FROM back_module bm";
        $sql.=" LEFT JOIN back_module bmp ON (bmp.module_id = bm.module_parent_id)";
        $sql.=" WHERE 1";
        if (!empty($formvars['module_page']))
            $sql.=" AND bm.module_page = '" . $formvars['module_page'] . "'";

        if (empty($champs)) {
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            return $this->sql->record;
        } else {
            $this->sql->query($sql, SQL_INIT, SQL_ASSOC);
            return $this->sql->record[$champs];
        }
    }

    function setVar($var, $value) {

        $this->$var = $value;
    }

    function getVar($var) {

        return $this->$var;
    }

    function addLabel($label) {

        if ($label->multi == false || ($label->multi == true && MULTI == 1)) {
            $label->setVar('pos', count($this->labels) + 2);
            array_push($this->labels, $label);
        }
    }

    function addForm($form) {

        $form->setVar('pos', count($this->labels) + 2);
        $form->setVar('parent', $this->name_url);
        array_push($this->forms, $form);
    }

    function displayPath() {

        $out = "<ol class='breadcrumb'>";
        foreach ($this->path as $link) {
            $out .= '<li>' . $link . '</li>';
        }
        $out .= "</ol>";

        return $out;
    }

    function displayList($type = 'html') {

        switch ($type) {
            case 'html':
                $out = $this->displayListHTML();
                break;
            case 'csv':
                $out = $this->displayListCSV();
                break;
            case 'sql':
                $out = $this->displayListSQL();
                break;
            case 'group':
                $out = $this->displayListGROUP();
                break;
            case 'simple':
                $out = $this->displayListSIMPLE();
                break;
            case 'graph':
                $out = $this->displayListGRAPH();
                break;
            case 'graphcsv':
                $out = $this->displayListGRAPHCSV();
                break;
            default :
                $out = $this->displayListHTML();
                break;
        }

        if ($this->div) {
            $out .= "<script type='text/javascript'>";
            $out .= "	var myTips = new Tips($$('.infobulle'));";
            $out .= "</script>";
        }
        return $out;
    }

    function update_multi($formvars = array(), $table = null, $langue = true) {
        $arrT = $this->bases;
        $parent_key = false;

        foreach ($arrT as $table) {

            $sql_insert = '';
            $sql = '';
            $clef = '';

            $sql = "DESC $table";

            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $rows = $this->sql->record;

            $sql_insert = "UPDATE $table SET ";
            $i = 0;
            $values = "";

            foreach ($rows as $tab_champ) {
                if ($tab_champ['Key'] != "PRI") {

                    if (isset($formvars[strtolower($tab_champ['Field'])])) {
                        if ($i != 0) {
                            $sql_insert.=", ";
                            $values.=", ";
                        }

                        if (($tab_champ['Type'] == "date" || $tab_champ['Type'] == "datetime") && $formvars[strtolower($tab_champ['Field'])]) {
                            if ($tab_champ['Type'] == "date")
                                $day = $formvars[strtolower($tab_champ['Field'])];
                            else
                                list($day, $time ) = explode(" ", $formvars[strtolower($tab_champ['Field'])]);

                            list($jours, $mois, $an) = explode("/", $day);

                            if ($tab_champ['Type'] == "date")
                                $formvars[strtolower($tab_champ['Field'])] = $an . '-' . $mois . '-' . $jours;
                            else
                                $formvars[strtolower($tab_champ['Field'])] = $an . '-' . $mois . '-' . $jours . ' ' . $time;
                            //$tab_champ['Field'] = "DATE_FORMAT(".$tab_champ['Field'].",'%d/%m/%Y')";
                        }
                        if ($formvars[strtolower($tab_champ['Field'])] == "NULL") {
                            $sql_insert.=$tab_champ['Field'] . " = " . $formvars[strtolower($tab_champ['Field'])];
                        } else {
                            if (get_magic_quotes_gpc()) {
                                $sql_insert.=$tab_champ['Field'] . " = \"" . $formvars[strtolower($tab_champ['Field'])] . "\"";
                            } else {
                                $sql_insert.=$tab_champ['Field'] . " = \"" . $this->sql->db->real_escape_string($formvars[strtolower($tab_champ['Field'])]) . "\"";
                            }
                        }
                        $i++;
                    }
                } else {
                    $clef = $tab_champ['Field'];
                }
            }

            if (!$parent_key)
                $parent_key = $clef;

            if (strpos($table, '_nom') !== false && $parent_key) {
                $sql_insert.=" WHERE " . $parent_key . " = '" . $formvars['back_id'] . "'";
                $sql_insert.=" AND langue_id = '" . LANGUE . "'";
            }
            else
                $sql_insert.=" WHERE $clef = '" . $formvars['back_id'] . "'";

            if ($i > 0)
                $req = $this->sql->query($sql_insert);
        }

        if ($langue) {
            //echo "lol";
            $this->updateLangue($formvars, $arrT[0]);
        }
    }

    function update($formvars = array(), $table = null, $langue = true) {

        $arrT = array();

        if ($table != null) {
            array_push($arrT, $table);
        } else {
            $arrT = $this->bases;
        }

        foreach ($arrT as $table) {
            $sql_insert = '';
            $sql = '';
            $clef = '';

            $sql = "DESC $table";
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $rows = $this->sql->record;

            $sql_insert = "UPDATE $table SET ";
            $i = 0;
            $values = "";

            foreach ($rows as $tab_champ) {
                if ($tab_champ['Key'] != "PRI") {
                    if (isset($formvars[strtolower($tab_champ['Field'])])) {
                        if ($i != 0) {
                            $sql_insert.=", ";
                            $values.=", ";
                        }

                        //$tmpField = $tab_champ['Field'];

                        if ($tab_champ['Type'] == "date" && $formvars[strtolower($tab_champ['Field'])]) {
                            list($jours, $mois, $an) = explode("/", $formvars[strtolower($tab_champ['Field'])]);

                            $formvars[strtolower($tab_champ['Field'])] = $an . '-' . $mois . '-' . $jours; //2007-08-04
                        }
                        if ($tab_champ['Type'] == "datetime" && $formvars[strtolower($tab_champ['Field'])]) {
                            //echo($tab_champ['Field'] . " - " .$formvars[strtolower($tab_champ['Field'])]."<br />");

                            list($day, $time ) = explode(" ", $formvars[strtolower($tab_champ['Field'])]);
                            list($jours, $mois, $an) = explode("/", $day);

                            $formvars[strtolower($tab_champ['Field'])] = $an . '-' . $mois . '-' . $jours . ' ' . $time; //2007-08-04
                        }

                        if ($formvars[strtolower($tab_champ['Field'])] == "NULL") {
                            $sql_insert.=$tab_champ['Field'] . " = " . $formvars[strtolower($tab_champ['Field'])];
                        } else {
                            if (get_magic_quotes_gpc()) {
                                $sql_insert.=$tab_champ['Field'] . " = \"" . $formvars[strtolower($tab_champ['Field'])] . "\"";
                            } else {
                                $sql_insert.=$tab_champ['Field'] . " = \"" . $this->sql->db->real_escape_string($formvars[strtolower($tab_champ['Field'])]) . "\"";
                            }
                        }
                        $i++;
                    }
                } else {
                    $clef = $tab_champ['Field'];
                }
            }

            $sql_insert.=" WHERE $clef = '" . $formvars['back_id'] . "'";

            $req = $this->sql->query($sql_insert);
        }

        if ($langue)
            $this->updateLangue($formvars, $arrT[0]);
        //--
    }

    function updateLangue($formvars, $table) {

        $lang = array();

        foreach ($formvars as $k => $v) {
            if (strpos($k, '|') !== false)
                list($langue_id, $champ) = explode("|", $k);
            else {
                $langue_id = $k;
                $champ = "";
            }
            if (!empty($langue_id) && !empty($champ)) {
                $lang[$langue_id][$champ] = $v;
            }
        }

        if ($lang) {

            foreach ($lang as $k => $v) {

                $sql = "SELECT " . $table . "_nom_id as id FROM " . $table . "_nom WHERE langue_id = " . $k . " AND " . $table . "_id = " . $formvars['back_id'] . "";
                $this->sql->query($sql, SQL_INIT, SQL_ASSOC);
                $nbResults = $this->sql->record['id'];

                if ($nbResults) {
                    $v['back_id'] = $nbResults;

                    BackModule::update($v, $table . '_nom', false);
                } else {

                    $v['langue_id'] = $k; //id de la langue
                    $v[$table . '_id'] = $formvars['back_id']; //table_id = ID parent
                    $tableTMP = $table . '_nom';

                    BackModule::create($v, $tableTMP, false);
                }
            }
        }
    }

    function duplicate($formvars = array(), $table = null, $langue = true) {

        $id = $this->create($formvars, $table, $langue);
        return $id;
    }

    function create($formvars = array(), $table = null, $langue = true) {

        if (empty($formvars['langue_id']))
            $formvars['langue_id'] = LANGUE;

        $arrT = array();

        if ($table == null)
            $arrT = $this->bases;
        else
            array_push($arrT, $table);

        foreach ($arrT as $table) {

            $sql_insert = '';
            $sql = '';

            $sql = "DESC $table";
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $rows = $this->sql->record;

            $sql_insert = "INSERT INTO $table (";
            $i = 0;
            $values = "";

            foreach ($rows as $tab_champ) {
                if (isset($formvars[strtolower($tab_champ['Field'])])) {
                    if ($i != 0) {
                        $sql_insert.=", ";
                        $values.=", ";
                    }

                    $sql_insert.=$tab_champ['Field'];

                    if ($tab_champ['Type'] == "date" && $formvars[strtolower($tab_champ['Field'])]) {
                        //list($day , $time ) = explode(" ",$formvars[strtolower($tab_champ['Field'])]);
                        list($jours, $mois, $an) = explode("/", $formvars[strtolower($tab_champ['Field'])]);

                        $formvars[strtolower($tab_champ['Field'])] = $an . '-' . $mois . '-' . $jours; //2007-08-04
                        //$tab_champ['Field'] = "DATE_FORMAT(".$tab_champ['Field'].",'%d/%m/%Y')";
                    }
                    if ($tab_champ['Type'] == "datetime" && $formvars[strtolower($tab_champ['Field'])]) {
                        list($day, $time ) = explode(" ", $formvars[strtolower($tab_champ['Field'])]);
                        list($jours, $mois, $an) = explode("/", $day);

                        $formvars[strtolower($tab_champ['Field'])] = $an . '-' . $mois . '-' . $jours . ' ' . $time; //2007-08-04
                        //$tab_champ['Field'] = "DATE_FORMAT(".$tab_champ['Field'].",'%d/%m/%Y')";
                    }
                    if ($formvars[strtolower($tab_champ['Field'])] == "NULL") {
                        $values.=$formvars[strtolower($tab_champ['Field'])];
                    } else {
                        if (get_magic_quotes_gpc()) {
                            $values.="\"" . $formvars[strtolower($tab_champ['Field'])] . "\"";
                        } else {
                            $values.="\"" . $this->sql->db->real_escape_string($formvars[strtolower($tab_champ['Field'])]) . "\"";
                        }
                    }


                    $i++;
                }
            }

            $sql_insert.=") VALUES ($values)";

            $req = $this->sql->query($sql_insert);

            $lastid = $this->sql->db->insert_id;
        }

        if (!empty($formvars['back_id'])) {
            $this->duplicateBoutique($formvars, $table, (int) $lastid);
        }

        $formvars['back_id'] = $lastid;

        if ($langue)
            $this->updateLangue($formvars, $arrT[0]);

        //exit;
        return $lastid;
        //--
    }

    function create_multi($formvars = array(), $table = null, $langue = true) {
        $formvars['langue_id'] = LANGUE;

        $arrT = array();
        if ($table == null)
            $arrT = $this->bases;
        else
            array_push($arrT, $table);

        foreach ($arrT as $table) {
            $sql_insert = '';
            $sql = '';

            $sql = "DESC $table";
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $rows = $this->sql->record;

            $sql_insert = "INSERT INTO $table (";
            $i = 0;
            $values = "";
            foreach ($rows as $tab_champ) {
                if ($tab_champ['Key'] == "PRI") {
                    $clef = $tab_champ['Field'];
                }

                if (isset($formvars[strtolower($tab_champ['Field'])])) {
                    if ($i != 0) {
                        $sql_insert.=", ";
                        $values.=", ";
                    }

                    $sql_insert.=$tab_champ['Field'];

                    if (($tab_champ['Type'] == "datetime") && $formvars[strtolower($tab_champ['Field'])]) {
                        list($day, $time ) = explode(" ", $formvars[strtolower($tab_champ['Field'])]);
                        list($jours, $mois, $an) = explode("/", $day);

                        $formvars[strtolower($tab_champ['Field'])] = $an . '-' . $mois . '-' . $jours . ' ' . $time; //2007-08-04
                        //$tab_champ['Field'] = "DATE_FORMAT(".$tab_champ['Field'].",'%d/%m/%Y')";
                    } elseif ($tab_champ['Type'] == "date" && $formvars[strtolower($tab_champ['Field'])]) {
                        list($jours, $mois, $an) = explode("/", $formvars[strtolower($tab_champ['Field'])]);

                        $formvars[strtolower($tab_champ['Field'])] = $an . '-' . $mois . '-' . $jours; //2007-08-04
                    }

                    if ($formvars[strtolower($tab_champ['Field'])] == "NULL") {
                        $values.=$formvars[strtolower($tab_champ['Field'])];
                    } else {
                        if (get_magic_quotes_gpc()) {
                            $values.="\"" . $formvars[strtolower($tab_champ['Field'])] . "\"";
                        } else {
                            $values.="\"" . $this->sql->db->real_escape_string($formvars[strtolower($tab_champ['Field'])]) . "\"";
                        }
                    }
                    $i++;
                }
            }

            $sql_insert.=") VALUES ($values)";

            //echo $sql_insert;exit();

            $req = $this->sql->query($sql_insert);

            $lastid = $this->sql->db->insert_id;

            $formvars[$clef] = $lastid;


            if (!isset($parent_key))
                $parent_key = $lastid;
        }

        if (!empty($formvars['back_id'])) {
            $this->duplicateBoutique($formvars, $arrT[0], (int) $parent_key);
        }


        $formvars['back_id'] = $parent_key;

        if ($langue)
            $this->updateLangue($formvars, $arrT[0]);

        return $parent_key;
    }

    function delete($formvars = array())
    {
        return $this->sql->query(sprintf('DELETE FROM %s WHERE %s_id = %s LIMIT 1', $this->bases[0], $this->bases[0], $formvars['back_id']));
    }

    function displayListCSV() {

        if (!$this->droits['EXP']) {
            $out = "ERROR 154 !!";
            return $out;
            exit;
        }

        // SEARCH
        $isSearch = count($this->forms) > 0;
        if ($isSearch) {

            $js = "";
            $inputSearch = "";
            for ($i = 0; $i < count($this->forms); $i++) {
                if (isset($_GET[$this->forms[$i]->name]))
                    $inputSearch .= $this->forms[$i]->Displayform($_GET[$this->forms[$i]->name], $this);
                else
                    $inputSearch .= $this->forms[$i]->Displayform("", $this);
                if ($this->forms[$i]->value != '') {
                    // $js.="showSearch('searchTableList');";
                    $this->urlForms.=$this->forms[$i]->getUrl();
                    $this->sqlForms.=$this->forms[$i]->getSql();
                }
            }
        }
        //-- SEARCH
        //  CONSTRUCTION DE LA REQUETE
        $sql = $this->request;
        $sql .=$this->sqlForms;

        // GROUP BY
        if ($this->groupBy)
            $sql.=" GROUP BY " . $this->groupBy;
        //-- GROUP BY
        // ORDER BY
        if (!empty($this->orderBy)) {
            if ($this->orderBy < 0)
                $sql.=" ORDER BY " . abs($this->orderBy) . " DESC";
            else
                $sql.=" ORDER BY " . $this->orderBy;
        }
        //-- ORDER BY
        // LIMIT
        //if($this->limit)
        //{
        //  $offset = ($this->page - 1) * $this->limit;
        //	$sql.=" LIMIT ".$offset.",".$this->limit;
        //}
        //-- LIMIT

        $this->sql->query($sql, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;

        header('Content-Disposition: attachment; filename="export_' . $this->name_url . '_' . date('Y_m_d', time()) . '.csv"');
        header("Content-type: text/csv; charset=UTF-8");
        $out = "";
        foreach ($this->labels as $label) {
            $out .= '"' . $label->name . '"';
            $out .= ";";
        }
        $out .= "\r\n";

        foreach ($rows as $row) {
            $i = 1;
            foreach ($this->labels as $label) {
                if ($label->name == "MESSAGE") {
                    $out .= ";";
                    $i++;
                    continue;
                }
                $row[$i] = html_entity_decode(utf8_decode($row[$i]));
                //$row[$i] = str_replace(".", ",", $row[$i]);
                $row[$i] = str_replace("\r\n", " ", $row[$i]);
                $row[$i] = str_replace("\n", " ", $row[$i]);
                $out .= '"' . $row[$i] . '"';
                $out .= ";";
                $i++;
            }
            $out .= "\r\n";
        }

        echo $out;
    }

    function displayListSQL() {

        // SEARCH
        $isSearch = count($this->forms) > 0;
        if ($isSearch) {
            $inputSearch = "";
            $js = "";
            for ($i = 0; $i < count($this->forms); $i++) {
                if (isset($_GET[$this->forms[$i]->name]))
                    $inputSearch .= $this->forms[$i]->Displayform($_GET[$this->forms[$i]->name], $this);
                else
                    $inputSearch .= $this->forms[$i]->Displayform('', $this);
                if ($this->forms[$i]->value != '') {
                    // $js.="showSearch('searchTableList');";
                    $this->urlForms.=$this->forms[$i]->getUrl();
                    $this->sqlForms.=$this->forms[$i]->getSql();
                }
            }
        }
        //-- SEARCH
        //  CONSTRUCTION DE LA REQUETE
        $sql = $this->request;
        $sql2 = $this->sqlForms;

        // GROUP BY
        if ($this->groupBy)
            $sql2.=" GROUP BY " . $this->groupBy;
        //-- GROUP BY
        // ORDER BY
        if (!empty($this->orderBy)) {
            if ($this->orderBy < 0)
                $sql2.=" ORDER BY " . abs($this->orderBy) . " DESC";
            else
                $sql2.=" ORDER BY " . $this->orderBy;
        }
        return array($sql, $sql2);
    }

    function displayListHTML()
    {

        if (!$this->droits['READ']) {
            header('Location: /back/');
            exit;
        }

        $out = "<section class='content-header'>";
        $out .= "<h1>" . $this->name . "</h1>";
        // $out .= $this->displayPath();

        $out.= '<div class="context-action">';

        if ($this->droits['ADD']) {
            $out .= ' <a class="btn btn-default btn-flat bg-olive margin-r-5" href="' . $this->link_to('addForm') . '"> <i class="fa fa-plus-square"></i> Ajouter </a>';
        }

        // Export
        $out.= '<a class="btn btn-default btn-flat margin-r-5" href="' . $this->link_to('export', array('type' => 'csv')) . '"><i class="fa fa-file-excel-o"></i> CSV </a>';


        $out .= $this->getHTMLExportImport(0);
        $out .= $this->getHTMLExportImport(1);

        if (!empty($this->docs)) {
            $out.= '<a class="btn btn-pinterest btn-flat margin-r-5" href="#null" data-toggle="control-sidebar"><i class="fa fa-info-circle"></i> Aide </a>';
        }

        $out .='</div>';
        $out .= "</section>";

        $out .= "<section class='content'>";

        // SEARCH
        $isSearch = count($this->forms) > 0;
        if ($isSearch) {

            $js = "";
            $inputSearch = "";

            for ($i = 0; $i < count($this->forms); $i++) {

                if (isset($_GET[$this->forms[$i]->name])) {
                    $inputSearch .= $this->forms[$i]->Displayform($_GET[$this->forms[$i]->name], $this);
                } else {
                    $inputSearch .= $this->forms[$i]->Displayform('', $this);
                }

                if ($this->forms[$i]->value != '') {
                    if (strpos($js, "show") === false)
                        // $js .= "showSearch('searchTableList');";
                    $this->urlForms .= $this->forms[$i]->getUrl();
                    $this->sqlForms .= $this->forms[$i]->getSql();
                }
            }

            $searchOpenIcon = 'fa-minus';
            $searchOpenClass = '';
            if ($this->openSearch == false) {
                $searchOpenClass = 'collapsed-box';
                $searchOpenIcon = 'fa-plus';
            }

            $search = '<div class="col-xs-12">';
            $search .= "<form id='form1' class='form-horizontal' action='" . $this->getUrl() . "' name='form1' method='get'>";
            $search .= "<div class='box box-solid box-primary $searchOpenClass'>";
            // TODO : option pour ouvrir par défaut la section recherche dans un module
            $search .= "<div class='box-header with-border'>
                            <h3 class='box-title'>Recherche</h3>
                            <div class='box-tools pull-right'>
                                <button type=\"button\" class=\"btn btn-box-tool\" data-widget=\"collapse\"><i class=\"fa $searchOpenIcon\"></i>
                    </button>
                            </div>
                        </div>";
            $search .= "<div class='box-body'>";

            $search .= "<input type='hidden' name='order' value='" . $this->orderBy . "' />";

            $search .= $inputSearch;
            $search .= "</div>";
            $search .= "<div class='box-footer'><button type='submit' class='btn btn-primary pull-right'>Appliquer</button></div>";


            $search .= "</div></form>";
            $search .= "</div>";
        }
        //-- SEARCH
        //  CONSTRUCTION DE LA REQUETE
        $sql = $this->request;
        $sql .= $this->sqlForms;

        // GROUP BY
        if ($this->groupBy)
            $sql .= " GROUP BY " . $this->groupBy;
        //-- GROUP BY
        // ORDER BY
        if (!empty($this->orderBy)) {
            if ($this->orderBy < 0)
                $sql .= " ORDER BY " . abs($this->orderBy) . " DESC";
            else
                $sql .= " ORDER BY " . $this->orderBy;
        }
        //-- ORDER BY
        // LIMIT
        if ($this->limit) {
            $offset = ($this->page - 1) * $this->limit;
            $sql .= " LIMIT " . $offset . "," . $this->limit;
        }
        //-- LIMIT
        //error_log($sql);
        $sql = preg_replace("#^SELECT([.])*#", "SELECT SQL_CALC_FOUND_ROWS\\1", $sql);

        //-- CONSTRUCTION
        //error_log($sql);
        //echo $sql;
        // RECUPERATION DES RESULTATS
        $this->sql->query($sql, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;
        // --
        // RECUPERATION DU NB DE LIGNES TOTALES
        $sql = "SELECT FOUND_ROWS() as nb_rows";
        $this->sql->query($sql, SQL_INIT, SQL_ASSOC);
        $nbResults = $this->sql->record['nb_rows'];
        // -- RECUPERATION DU NB DE LIGNES TOTALES
        // CONSTRUCTION DE LA PAGINATION
        if ($this->limit)
            $nbPage = ceil($nbResults / $this->limit); //Nombre total
        else {
            $nbPage = 1;
            $this->limit = $nbResults;
        }

        $curPage = $this->page; //Page en cours



        $records = '';

        $debut = $offset + 1;
        $fin = $offset + $this->limit;
        if ($fin > $nbResults)
            $fin = $nbResults;

        $records.= '<div class="col-xs-6">';
        if ($nbResults > 0) {
            $records .= $debut . " - " . $fin . " sur ";
        }
        $records .= $nbResults . " r&eacute;sultat";
        if ($nbResults > 1) {
            $records .= "s";
        }

        $records .= '- Affichage :';
        $records.= '</div>';

        $records.= '<div class="col-xs-3">';
        $records .= '<select class="form-control" onchange="change_limit(this.options[this.selectedIndex].value,\'' . $this->name_url . '\',\'' . urlencode($this->pageUrl(1)) . '\');">';

        $arrLim = array('10', '25', '50', '100', '250', '500');
        foreach ($arrLim as $valLim) {
            $selected = (($this->limit == $valLim) ? 'selected="selected"' : '');
            $records .= '<option value="' . $valLim . '" ' . $selected . '>' . $valLim . '</option>';
        }

        $records .= '</select>';
        $records.= '</div>';



        $records.= "<ul class='pagination pagination-sm no-margin'>";
        if ($nbPage > 1) {

            if ($curPage > 1) {
                $records .= "<li><a href='" . $this->pageUrl(1) . "'>&laquo;</a></li>";
                $records .= "<li><a href='" . $this->pageUrl($curPage - 1) . "'>&lsaquo;</a></li>";
            }
            if ($curPage != 1)
                $records .= "<li><a href='" . $this->pageUrl(1) . "'>1</a></li>";
            if ($curPage - 3 > 2)
                $records .= "<li class=\"disabled\"><a href='#null'> ... </a></li>";
            if ($curPage - 3 == 2)
                $records .= "<li><a href='" . $this->pageUrl($curPage - 3) . "'>" . ($curPage - 3) . "</a></li>";
            if ($curPage - 2 > 1)
                $records .= "<li><a href='" . $this->pageUrl($curPage - 2) . "'>" . ($curPage - 2) . "</a></li>";
            if ($curPage - 1 > 1)
                $records .= "<li><a href='" . $this->pageUrl($curPage - 1) . "'>" . ($curPage - 1) . "</a></li>";
            $records .= '<li class="disabled"><a href="#null">' . $curPage . '</a></li> ';
            if ($curPage + 1 < $nbPage)
                $records .= "<li><a href='" . $this->pageUrl($curPage + 1) . "'>" . ($curPage + 1) . "</a></li>";
            if ($curPage + 2 < $nbPage)
                $records .= "<li><a href='" . $this->pageUrl($curPage + 2) . "'>" . ($curPage + 2) . "</a></li>";
            if ($curPage + 3 < $nbPage)
                $records .= "<li class=\"disabled\"><a href='#null'> ... </a></li>";
            if ($curPage != $nbPage)
                $records .= "<li><a href='" . $this->pageUrl($nbPage) . "'>" . $nbPage . "</a></li>";
            if ($curPage < $nbPage) {
                $records .= "<li><a href='" . $this->pageUrl($curPage + 1) . "'>&rsaquo;</a></li>";
                $records .= "<li><a href='" . $this->pageUrl($nbPage) . "'>&raquo;</a></li>";
            }

        }
        $records .= "</ul>";


        //-- CONSTRUCTION DE LA PAGINATION

        $searchClass = (($isSearch) ? "" : "disabled");

        $out.= "<div class='row'>";

        if (!empty($search)) {
            $out .= $search;
        }

        $out .= "</div>";

        // $out .= "</div>";


        $out .= "<div>";

        $out .= "<div class='box box-primary'>";
        $out .= '<div class="box-header with-border">
                    <div class="col-md-6"><h3 class="box-title">Résultats</h3></div>';
        $out .= '<div class="col-md-6 text-right">' . $records . '</div>'; // AFFICHAGE DE LA PAGINATION
        $out.='</div>';
        $out .= "<div class='box-body'>";
        $out .= "<div class='table-responsive no-padding'>";
        $out .= "<table id='back_results' class='table table-hover table-bordered'>";
        // $out.="<col width='20px'>";
        // AFFICHAGE DES EN-TETES
        $out .= "<thead>";
        $out .= "<tr>";
        $nbLabels = 1;
        foreach ($this->labels as $label) {
            $nbLabels++;
            $out .= $label->displayName($this);
        }
        $out .= "</tr>";
        $out .= "</thead>";
        // --
        // AFFICHAGE DES RESULTATS
        $out .= "<tbody>";
        $highlight = 0;
        foreach ($rows as $row) {
            $highlight = abs(1 - ($highlight));

            $class = (($highlight) ? 'highlight' : '');

            $out .= "<tr id='" . $this->name_url . "_line_" . $row[0] . "' class='resultr $class'>";

//			if($this->droits['CONTEXT'] && ($this->droits['MOD'] || $this->droits['DEL']))

            if ($this->droits['CONTEXT'] && $this->droits['MOD'] && $row[0] != 'no_context') {

                $out.="<td width='120px'>" . $this->displayContextMenu($row[0]) . "</td>";
            }

            if ($row[0] == 'no_context')
                $out .= "<td width='120px'></td>";

            $i = 1;
            foreach ($this->labels as $label) {
                $label->setVar('curID', $row[0]);
                $out .= $label->displayData($this, @$row[$i]);
                $i++;
            }
            $out .= "</tr>";
            $out .= "\n";
        }

        $displayNoRows = ((count($rows) > 0) ? 'display:none;' : 'display:cell;' );

        $out .= "<tr><td id='noresultr' colspan='" . $nbLabels . "' style='" . $displayNoRows . "text-align:center;font-weight:bold;text-align:center;'>Aucun R&eacute;sultat</td></tr>";
        $out .= "</tbody>";
        //-- AFFICHAGE DES RESULTATS
        $out .= "</table>";

        $out .= "</div>";
        $out .= "</div>";

        $out .=  '<div class="box-footer">';
        $out .=  '<div class="col-md-6"></div>';
        $out .= '<div class="col-md-6 text-right">' . $records . '</div>'; // AFFICHAGE DE LA PAGINATION
        $out .=  '</div>';

        $out .= "</div>";
        $out .= "</div>";

        $out .= "</section>";       // fin section .content

        //$out .= "<form id='ajax_form'><input name='ajax_obj' id='ajax_obj' type='text' value='".urlencode(gzencode(serialize($this)))."' /></form>";

        $out .= "<script type='text/javascript'>";
        if (!empty($js))
            $out .= $js;
        $out .= "</script>";

        if (!empty($this->docs)) {
            if (is_array($this->docs)) {
                $docHtml = array();
                foreach ($this->docs as $name => $fileDoc) {
                    $docHtml[$name] = \Michelf\Markdown::defaultTransform(file_get_contents($fileDoc));
                }
            } else {
                $docHtml = \Michelf\Markdown::defaultTransform(file_get_contents($this->docs));
            }

            // TODO : add button export PDF
            $out.='
            <!-- Control Sidebar -->
            <aside class="control-sidebar control-sidebar-dark">
            ';

            $out.='<button class="btn btn-xs btn-pinterest pull-right" data-toggle="control-sidebar"><i class="fa fa-remove"></i> Fermer</button>';

            $first = true;
            if (is_array($docHtml)) {
                $out.= '<ul class="nav nav-tabs nav-justified control-sidebar-tabs">';
                foreach ($docHtml as $name => $content) {

                    $class = '';
                    if ($first) {
                        $first = false;
                        $class = 'active';
                    }

                    $out.= '<li class="'.$class.'">
                                <a href="#'.Tools::parseURL($name).'" data-toggle="tab">
                                    '.$name.'
                                </a>
                            </li>';
                }

                $out.= '</ul>';
            }

            $out.= '<div class="tab-content">';

            if (is_array($docHtml)) {
                $first = true;
                foreach ($docHtml as $name => $content) {

                    $class = '';
                    if ($first) {
                        $first = false;
                        $class = 'active';
                    }

                    $out .= '<div class="tab-pane '.$class.'" id="'.Tools::parseURL($name).'">'.$content.'</div>';
                }
            } else {
                $out .= '<div class="tab-pane active">'.$docHtml.'</div>';
            }

            $out.='</div>';

            $out.='</aside>
            <!-- /.control-sidebar -->
            <!-- Add the sidebars background. This div must be placed
                 immediately after the control sidebar -->
            <div class="control-sidebar-bg"></div>
            ';
        }

        return $out;
    }

    function displayListGROUP() {

        if (!$this->droits['READ']) {
            return "Vous n'avez pas les droits n&eacute;c&eacute;ssaires.";
            exit;
        }

        //  CONSTRUCTION DE LA REQUETE
        $sql = $this->request;
        $sql .=$this->sqlForms;

        // GROUP BY
        if ($this->groupBy)
            $sql.=" GROUP BY " . $this->groupBy;
        //-- GROUP BY
        // ORDER BY
        if (!empty($this->orderBy)) {
            if ($this->orderBy < 0)
                $sql.=" ORDER BY " . abs($this->orderBy) . " DESC";
            else
                $sql.=" ORDER BY " . $this->orderBy;
        }
        //-- ORDER BY
        // LIMIT
        if ($this->limit) {
            //$offset = ($this->page - 1) * $this->limit;
            $offset = 0;
            $sql.=" LIMIT " . $offset . "," . $this->limit;
        }
        //-- LIMIT
        //echo htmlentities($sql);

        $sql = preg_replace("#^SELECT([.])*#", "SELECT SQL_CALC_FOUND_ROWS\\1", $sql);

        //-- CONSTRUCTION
        // RECUPERATION DES RESULTATS
        $this->sql->query($sql, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;
        // --
        // RECUPERATION DU NB DE LIGNES TOTALES
        $sql = "SELECT FOUND_ROWS() as nb_rows";
        $this->sql->query($sql, SQL_INIT, SQL_ASSOC);
        $nbResults = $this->sql->record['nb_rows'];
        // -- RECUPERATION DU NB DE LIGNES TOTALES

        $out = '';
        $out = "<div class='table-responsive no-padding' id='field_".$this->name_url."'>";
        // $out .= "<div class='table'>";
        $out .= "<table class='table table-hover table-bordered'>";
        // AFFICHAGE DES EN-TETES
        $out .= "<thead>";

        $out .= "<tr id='tr_" . $this->name_url . "'>";
        $nbLabels = 1;
        foreach ($this->labels as $label) {
            $nbLabels++;
            $out .= $label->displayName($this);
        }
        $out .= "</tr>";
        $out .= "</thead>";
        // --
        // AFFICHAGE DES RESULTATS
        $out .= "<tbody>";
        $highlight = 0;
        foreach ($rows as $row) {
            $highlight = abs(1 - ($highlight));

            $class = (($highlight) ? 'highlight' : '');

            $out .= "<tr id='" . $this->name_url . "_line_" . $row[0] . "' class='resultr $class'>";

//			if($this->droits['CONTEXT'] && ($this->droits['MOD'] || $this->droits['DEL']))

            if ($this->droits['CONTEXT'] && $this->droits['MOD'] && $row[0] != 'no_context')
                $out.="<td width='120px'>" . $this->displayContextMenu($row[0], 'ajax_pop') . "</td>";

            if ($row[0] == 'no_context')
                $out .= "<td width='120px'></td>";

            $i = 1;
            foreach ($this->labels as $label) {
                $label->setVar('curID', $row[0]);
                $out .= $label->displayData($this, $row[$i]);
                $i++;
            }
            $out .= "</tr>";
            $out .= "\n";
        }

        $displayNoRows = ((count($rows) > 0) ? 'display:none;' : 'display:cell;' );

        $out .= "<tr style='" . $displayNoRows . "'><td colspan='" . $nbLabels . "' style='text-align:center;font-weight:bold;text-align:center;'>Aucun R&eacute;sultat</td></tr>";
        $out .= "</tbody>";
        //-- AFFICHAGE DES RESULTATS
        $out .= "</table>";
        $out .= "</div>";

        $out .= "<script type='text/javascript'>";
        if (!empty($js))
            $out .= $js;

        $out .= "</script>";

        return $out;
    }

    function displayML($base, $form) {
        $sql = "SELECT b." . $base . "_nom_id, b." . $form->name . " as data, l.langue_id, l.langue_ini, l.langue_img FROM langue l LEFT JOIN " . $base . "_nom b ON (l.langue_id = b.langue_id AND b." . $base . "_id = '" . $form->curID . "') WHERE l.langue_ini <> '" . LANGUE_ISO . "' ";
        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $rows = $this->sql->record;
        $name = $form->name;

        $out = '';

        foreach ($rows as $row) {
            $form->setVar('translate', $row['langue_ini']);
            $form->setVar('champs', $name);
            $form->delAttr('class', 'required');
            $form->delAttr('id', $name . '_' . $row['langue_id']);
            $form->addAttr('id', $name . '_' . $row['langue_id']);
            $form->setVar('name', $row['langue_id'] . '|' . $name);
            $out .= $form->displayForm($row['data'], $this);
        }

        return $out;
    }

    function displayListSIMPLE() {

        // SEARCH
        $isSearch = count($this->forms) > 0;
        if ($isSearch) {

            $js = "";
            $inputSearch = "";
            for ($i = 0; $i < count($this->forms); $i++) {
                if (isset($_GET[$this->forms[$i]->name]))
                    $inputSearch .= $this->forms[$i]->Displayform($_GET[$this->forms[$i]->name], $this);
                else
                    $inputSearch .= $this->forms[$i]->Displayform("", $this);
                if ($this->forms[$i]->value != '') {
                    $this->urlForms.=$this->forms[$i]->getUrl();
                    $this->sqlForms.=$this->forms[$i]->getSql();
                }
            }

            $search = "<div id='searchTableList' class='records'>";
            $search .="<table style='border:1px solid #666;border-top:3px solid #666' class='records'><tr><td>";
            $search .="<form onsubmit=\"checkForm(this);return false;\" id='form1' action='" . $this->getUrl() . "' name='form1' method='get'>";
            $search .="<input type='hidden' name='order' value='" . $this->orderBy . "' />";
            $search .="<table style='width:100%'><tr><td style='border:0'>";
            $search .="<fieldset class='searchList'>";
            $search .= $inputSearch;
            $search .="</fieldset></td><td style='border:0' valign='bottom'><p class='SubmitP'><input type='submit' value='Appliquer' /></p>";
            $search .="</td></tr></table></form></td></tr></table></div>";
        }
        //-- SEARCH
        //  CONSTRUCTION DE LA REQUETE
        $sql = $this->request;
        $sql .=$this->sqlForms;

        // GROUP BY
        if ($this->groupBy)
            $sql.=" GROUP BY " . $this->groupBy;
        //-- GROUP BY
        // ORDER BY
        if (!empty($this->orderBy)) {
            if ($this->orderBy < 0)
                $sql.=" ORDER BY " . abs($this->orderBy) . " DESC";
            else
                $sql.=" ORDER BY " . $this->orderBy;
        }
        //-- ORDER BY
        // LIMIT
        if ($this->limit) {
            $offset = ($this->page - 1) * $this->limit;
            $sql.=" LIMIT " . $offset . "," . $this->limit;
        }
        //-- LIMIT


        $sql = preg_replace("#^SELECT([.])*#", "SELECT SQL_CALC_FOUND_ROWS\\1", $sql);

        //-- CONSTRUCTION
        // RECUPERATION DES RESULTATS
        $this->sql->query($sql, SQL_ALL, SQL_INDEX);
        $rows = $this->sql->record;
        // --
        // RECUPERATION DU NB DE LIGNES TOTALES
        $sql = "SELECT FOUND_ROWS() as nb_rows";
        $this->sql->query($sql, SQL_INIT, SQL_ASSOC);
        $nbResults = $this->sql->record['nb_rows'];
        // -- RECUPERATION DU NB DE LIGNES TOTALES
        // CONSTRUCTION DE LA PAGINATION
        if ($this->limit)
            $nbPage = ceil($nbResults / $this->limit); //Nombre total
        else {
            $nbPage = 1;
            $this->limit = $nbResults;
        }

        $curPage = $this->page; //Page en cours

        $records = "<table style='margin:0' id='%ID_RECORDS%' class='records'>";
        $records .= "<tbody><tr><td class='table_controls'><div class='box box-solid box-primary'>";

        $records .= "<div class='filter_controls'>";
        if ($nbPage > 1) {
            $records .= "<span class='button_label'>";

            if ($curPage > 1) {
                $records .= "<a href='" . $this->pageUrl(1) . "'><img alt='page_start' src='" . BACK_URL . "styles/images/page_start.png' /></a> ";
                $records .= "<a href='" . $this->pageUrl($curPage - 1) . "'><img alt='page_previous' src='" . BACK_URL . "styles/images/page_previous.png' /></a> ";
            }
            if ($curPage != 1)
                $records .= "<a href='" . $this->pageUrl(1) . "'>1</a> ";
            if ($curPage - 3 > 2)
                $records .= " ... ";
            if ($curPage - 3 == 2)
                $records .= "<a href='" . $this->pageUrl($curPage - 3) . "'>" . ($curPage - 3) . "</a> ";
            if ($curPage - 2 > 1)
                $records .= "<a href='" . $this->pageUrl($curPage - 2) . "'>" . ($curPage - 2) . "</a> ";
            if ($curPage - 1 > 1)
                $records .= "<a href='" . $this->pageUrl($curPage - 1) . "'>" . ($curPage - 1) . "</a> ";
            $records .= '<b>' . $curPage . '</b> ';
            if ($curPage + 1 < $nbPage)
                $records .= "<a href='" . $this->pageUrl($curPage + 1) . "'>" . ($curPage + 1) . "</a> ";
            if ($curPage + 2 < $nbPage)
                $records .= "<a href='" . $this->pageUrl($curPage + 2) . "'>" . ($curPage + 2) . "</a> ";
            if ($curPage + 3 < $nbPage)
                $records .= " ... ";
            if ($curPage != $nbPage)
                $records .= "<a href='" . $this->pageUrl($nbPage) . "'>" . $nbPage . "</a> ";
            if ($curPage < $nbPage) {
                $records .= "<a href='" . $this->pageUrl($curPage + 1) . "'><img alt='page_next' src='" . BACK_URL . "styles/images/page_next.png' /></a> ";
                $records .= "<a href='" . $this->pageUrl($nbPage) . "'><img alt='page_end' src='" . BACK_URL . "styles/images/page_end.png' /></a> ";
            }

            $records .= "</span>";
        }
        $records .= "</div>";

        $records .= '<div class="pagination_controls">';

        $debut = $offset + 1;
        $fin = $offset + $this->limit;
        if ($fin > $nbResults)
            $fin = $nbResults;

        $records .= '<span class="button_label">';
        if ($nbResults > 0
        )
            $records .= $debut . " - " . $fin . " sur ";
        $records .= $nbResults . " r&eacute;sultat";
        if ($nbResults > 1)
            $records.="s";
        $records .= '</span>';
        $records .= '</div>';

        $records .= "</div></td></tr></tbody>";
        $records .= "</table>";
        //-- CONSTRUCTION DE LA PAGINATION


        $searchClass = (($isSearch) ? "" : "off");

        $out = "<div>";
        $out .= "<div class='table'>";
        if (!empty($search))
            $out .= $search;


        //MINI FORM
        if ($this->miniForm) {
            $out .="<form onsubmit=\"checkForm(this);return false;\" action='" . $this->getUrl() . "?" . $_SERVER['QUERY_STRING'] . "' method='post' name='miniForm'>";
            $out .="<input type='hidden' name='submitBTN' value='' />";
        }
        //-- MINI FORM

        $out .= "<table class='records'>";
        // AFFICHAGE DES EN-TETES
        $out .= "<thead>";
        $out .= "<tr>";
        $nbLabels = 1;
        foreach ($this->labels as $label) {
            $nbLabels++;
            $out .= $label->displayName($this);
        }
        $out .= "</tr>";
        $out .= "</thead>";
        // --
        // AFFICHAGE DES RESULTATS
        $out .= "<tbody>";
        $highlight = 0;
        foreach ($rows as $row) {
            $highlight = abs(1 - ($highlight));

            $class = (($highlight) ? 'highlight' : '');

            $out .= "<tr id='" . $this->name_url . "_line_" . $row[0] . "' class='resultr $class'>";

            $i = 1;
            foreach ($this->labels as $label) {
                $label->setVar('curID', $row[0]);
                $out .= $label->displayData($this, $row[$i]);
                $i++;
            }
            $out .= "</tr>";
            $out .= "\n";
        }

        $displayNoRows = ((count($rows) > 0) ? 'display:none;' : 'display:cell;' );

        $out .= "<tr><td id='noresultr' colspan='" . $nbLabels . "' style='" . $displayNoRows . "text-align:center;font-weight:bold;text-align:center;'>Aucun R&eacute;sultat</td></tr>";
        $out .= "</tbody>";
        //-- AFFICHAGE DES RESULTATS
        $out .= "</table>";

        $out .= str_replace('%ID_RECORDS%', 'records_bottom', $records); // AFFICHAGE DE LA PAGINATION
        //MINI FORM
        if ($this->miniForm) {
            $out .= "<table class='records'><tr><td>";

            $out .= "<input style='width:100%' type='submit' onclick=\"document.miniForm.submitBTN.value=this.value;\" name='" . $this->miniForm['submitName'] . "' value='" . $this->miniForm['submitValue'] . "'>";
            $out .= "</td></tr></table>";
            $out .= "</form>";
        }
        //-- MINI FORM

        $out .= "</div>";
        $out .= "</div>";

        //$out .= "<form id='ajax_form'><input name='ajax_obj' id='ajax_obj' type='text' value='".urlencode(gzencode(serialize($this)))."' /></form>";

        /*$out .= "<script type='text/javascript'>";
        $out .= "	initPopUp('div_ajaxForm');";
        $out .= "</script>";*/

        return $out;
    }

    function displayForm($id, $div = '') {
        $modalDisplay = ($div == 'ajax_pop');
        $out = "";
        $form = new BackForm("Date Modif", "back_now", $this->name_url . "_date_modif");
        $this->addForm($form);

        if (!$id) {
            $form = new BackForm("Date Ajout", "back_now", $this->name_url . "_date_ajout");
            $this->addForm($form);
        }

        $div = $this->div;

        if ($id && !$this->droits['MOD']) {
            $out = "Vous ne disposez pas des autorisations n&eacute;c&eacute;ssaires";
            return $out;
            exit;
        } else if (!$id && !$this->droits['ADD']) {
            $out = "Vous ne disposez pas des autorisations n&eacute;c&eacute;ssaires";
            return $out;
            exit;
        }

        $formID = (($div) ? $div : 'form1');

        if (empty($div)) {
            // $out .= $this->displayPath();

            $out .= "<section class='content-header'>";
            $out .= "<h1>" . $this->name . "</h1>";
            $out .= $this->displayPath();
            $out .= "</section>";

            $out .= "<section class='content'>";

        }


        // RECUPERATION DES RESULTATS
        if ($id) {
            $sql = $this->request;
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $_POST = $this->sql->record[0];
            if (!$_POST)
                die();
        }
        //--
        // FORM


        $search = '';

        $search .="<form class='form-horizontal' id='" . $formID . "' action='" . $this->link_to('modSQL') . "' name='" . $formID . "' method='post'>";


        if($modalDisplay) $search .= "<div class='modal-header'>";
        $search .= $this->getButtonAction($formID, $id, $div, $modalDisplay);
        if($modalDisplay) $search .= "</div>";

        if($modalDisplay){
            $search .= "<div class='modal-body'>";
            $search .= "<section class='content'>";
        }

        $search .="<input type='hidden' name='back_class' value='" . $this->name_url . "' />";
        $search .="<input type='hidden' name='back_type' value='' />";
        $search .="<input type='hidden' name='back_id' value='" . $id . "' />";

        $search.= "<div class='row'>";
        for ($i = 0; $i < count($this->forms); $i++) {

            if (isset($_GET[$this->forms[$i]->name]))
                $_POST[$this->forms[$i]->name] = $_GET[$this->forms[$i]->name];

            $this->forms[$i]->setVar('formID', $formID);
            $this->forms[$i]->setVar('curID', $id);

            if ($i == 0 && $this->forms[$i]->getVar('type') != 'group') { //Si aucun group n'est d襩ni dans la class, on en ajoute un par d襡ut
                $form = new BackForm("", "group");
                $search .= $form->displayGroup($i);
                if (isset($_POST[$this->forms[$i]->name]))
                    $search .= $this->forms[$i]->displayForm($_POST[$this->forms[$i]->name], $this);
                else
                    $search .= $this->forms[$i]->displayForm('', $this);
            }
            elseif ($this->forms[$i]->getVar('type') == 'group') { //Si le group est la
                $class = $this->forms[$i]->getGroupOpts('class');

                if (empty($class) || (!empty($class) && !empty($id))) {

                    if (!empty($class)) {
                        $paramAdd['module_page'] = $class;
                        $paramAdd['parent_url'] = $this->name_url;

                        $class = getClassNameModule($class);
                        $obj = new $class($paramAdd);

                        $paramGroup['type'] = 'group'; //csv&co
                        $paramGroup[$this->name_url] = $id;

                        $search .= $this->forms[$i]->displayGroup($i, $obj);
                        $search .= $obj->Listing($paramGroup);
                    }
                    else
                        $search .= $this->forms[$i]->displayGroup($i);
                }
            }
            else {
                $this->forms[$i]->setVar('curID', $id);
                if (isset($_POST[$this->forms[$i]->name]))
                    $search .= $this->forms[$i]->displayForm($_POST[$this->forms[$i]->name], $this);
                else
                    $search .= $this->forms[$i]->displayForm('', $this);
            }

            if ($this->forms[$i]->value != '') {
                $this->urlForms.=$this->forms[$i]->getUrl();
                $this->sqlForms.=$this->forms[$i]->getSql();
            }
        }

        // $search.= "</div>";



        // $search .="</fieldset>";
        $search .="</div></div></div>";
        $search .="</div>";     // fin .row

        if(!$modalDisplay) $search .= $this->getButtonAction($formID, $id, $div);
            // $search .="</td></tr></table></div>";
        //--
        //$search .="<p class='SubmitP'><input onclick=\"$('back_type').value='cmd_back';\" type='submit' name='cmd_back'  id='cmd_back' value='Modifier... et Retourner sur le listing' /></p>";
        //$search .="<input type='checkbox' name='cmd_autosave' value='1' /><span>Sauvegarder automatiquement toutes les 5 minutes</span>";

        $addClass = (!empty($_GET['id']) ? "" : "current");
        $modClass = (!empty($_GET['id']) ? "current" : "off");
        $dupClass = (!empty($_GET['id']) ? "off" : "off");
        $delClass = (!empty($_GET['id']) ? "" : "off");

        $out .= $search;

        if($modalDisplay) {
            $out .= '</section>';
            $out .= '</div>';
            $out .= "<div class='modal-footer'>";
            $out .= $this->getButtonAction($formID, $id, $div, $modalDisplay);
            $out .= "</div>";
        }

            $out .="</form>";

        $out.= "
        <script>
           jQuery('#".$formID."').validator().on('submit', function (e) {
              if (e.isDefaultPrevented()) {
                // handle the invalid form...
              } else {
                // everything looks good!
                validateForm(true, document.getElementById('".$formID."'));
                return false;
              }
            });
        </script>
        ";


        return $out;
    }

    function getButtonAction($formID, $id, $div, $modalDisplay = false)
    {
        $search = "";
        if(!$modalDisplay){
            $search .="<div class='box sticky'>";
            $search .="<div class='box-body'>";
        }




        $search .="<div class='pull-right'>";

        if (empty($div)) {
            $search .="<button class='btn-flat btn btn-success' onclick=\"document." . $formID . ".back_type.value='cmd_back';\" type='submit' name='cmd_back'><i class='fa fa-check'></i> Valider</button> ";
            $search .="<button class='btn btn-flat btn-primary' onclick=\"document." . $formID . ".back_type.value='cmd_stay';\" type='submit' name='cmd_stay'><i class='fa fa-repeat'></i> Valider et Rester</button> ";
            if (!$id) {
                $search .= "<button class='btn btn-flat btn-primary' onclick=\"document." . $formID . ".back_type.value='cmd_new';\" type='submit' name='cmd_new'><i class='fa fa-plus'></i> Valider et Ajouter</button>";
            } else {
                if ($this->droits['DUP']) {
                    $search .= " <button class='btn btn-flat btn-warning' onclick=\"document." . $formID . ".back_type.value='cmd_duplicate';\" type='submit' name='cmd_duplicate'><i class='fa fa-files-o'></i> Dupliquer</button>";
                }
            }

            if (!empty($id) && $this->droits['DEL'] && $modalDisplay == false) {
                $search .= ' <button onclick="delete_item(\'' . $this->link_to('deleteItem') . '\',\'' . (isset($_GET['id']) ? $_GET['id'] : '') . '\');return false;" class="btn btn-flat btn-danger"><i class="fa fa-remove"></i> Supprimer</button>';
            }

        } else {
            $search .="<button class='btn btn-flat btn-primary' onclick=\"document." . $formID . ".back_type.value='cmd_stay';\" type='submit' name='cmd_stay'><i class='fa fa-repeat'></i> Valider et Rester</button> ";
            $search .= "<button class='btn btn-flat btn-success' onclick=\"document." . $formID . ".back_type.value='cmd_save_back';\" type='submit' name='cmd_save_back'>Valider</button>";
        }


        $modalDismiss = ($modalDisplay) ? " data-dismiss='modal'" : 'onclick = "location.href = \''.$this->link_to('searchList').'\';return false;"';
        $search .=" <button class='btn btn-flat btn-info'" . $modalDismiss . "><i class='fa fa-reply'></i> Retour</button> ";

        $search .="</div>";
        if(!$modalDisplay){
            $search .="</div>";
            $search .="</div>";
        }

        return $search;
    }

    function displayContextMenu($id, $div = '') {

        $out = '';
        if ($this->droits['MOD']) {
            $out.= '<div class="btn-group">';
            if (!empty($div)) {
                $out .= "<button class='btn btn-default btn-flat' onclick=\"ajax_form('" . $this->link_to('modForm', array('id' => $id, 'div' => $div)) . "');return false;\"><i class='fa fa-edit'></i> Editer</button>";
                if ($this->droits['DEL']) {
                    $out.='<button type="button" class="btn btn-default btn-flat dropdown-toggle" data-toggle="dropdown" aria-expanded="false">
                    <span class="caret"></span>
                    <span class="sr-only">Toggle Dropdown</span>
                  </button>';
                    $out.='<ul class="dropdown-menu" role="menu">';
                    $out .= " <li><a href='#null' onclick=\"delete_item('" . $this->link_to('deleteItem', array('div' => $this->name_url . '_line_' . $id, 'refresh' => $this->name_url)) . "','" . $id . "'); return false;\"><i class='fa fa-remove'></i> Supprimer</a></li>";
                    $out .= '</ul>';
                }
            } else {
                $out .= " <button class='btn btn-default btn-flat' onclick=\"window.location.href='" . $this->link_to('modForm', array('id' => $id)) . "'\"><i class='fa fa-edit'></i> Editer</button>";
                if ($this->droits['DEL']) {
                    $out.='<button type="button" class="btn btn-default btn-flat dropdown-toggle" data-toggle="dropdown" aria-expanded="false">
                    <span class="caret"></span>
                    <span class="sr-only">Toggle Dropdown</span>
                  </button>';
                    $out.='<ul class="dropdown-menu" role="menu">';
                    $out .= " <li><a href='#null' onclick=\"delete_item('" . $this->link_to('deleteItem', array('div' => $this->name_url . '_line_' . $id)) . "','" . $id . "'); return false;\"><i class='fa fa-remove'></i> Supprimer</a></li>";
                    $out .= '</ul>';
                }
            }
            $out.= "</div>";
        }

        return $out;
    }

    function pageUrl($page) {



        $url = $this->link_to('cleanList');
        $url.="?page=" . $page;
        $url.="&amp;order=" . $this->orderBy;
        $url.=$this->urlForms;
        return $url;
    }

    function orderUrl($order) {
        $url = $this->link_to('cleanList');
        $url.="?page=1";
        $url.="&amp;order=" . $order;
        $url.=$this->urlForms;
        return $url;
    }

    function link_to($item = '', $formvars = array()) {

        $params = $this->getUrl('query');
        if(!empty($params))
            $params = '?' . htmlentities($params);

        switch ($item) {
            case 'addForm':
                if (!empty($formvars)) {
                    foreach ($formvars as $k => $v) {
                        $params .= ( empty($params) ? '?' . $k . '=' . $v : '&amp;' . $k . '=' . $v );
                    }
                }
                $out = '/back/html/' . $this->name_url . '/form/' . $params;
                break;
            case 'modForm':
                if (!empty($formvars['div'])) {
                    $div = 'div=' . $formvars['div'];
                    $params .= ( empty($params) ? '?' . $div : '&amp;' . $div );
                }
                if (empty($formvars['id']))
                    die('no id for modForm');
                $out = '/back/html/' . $this->name_url . '/form/' . $formvars['id'] . '/' . $params;
                break;
            case 'contextMenu':
                if (!empty($formvars['div'])) {
                    $div = 'div=' . $formvars['div'];
                    $params .= ( empty($params) ? '?' . $div : '&amp;' . $div );
                }
                $out = '/back/html/' . $this->name_url . '/context/' . $formvars['id'] . '/' . $params;
                break;
            case 'modSQL':
                $out = '/back/html/' . $this->name_url . '/update/' . $params;
                break;
            case 'searchList':
                $out = '/back/html/' . $this->name_url . '/list/' . $params;
                break;
            case 'cleanList':
                if (!empty($_GET['method'])) {
                    if (!isset($_GET['id']))
                        $_GET['id'] = "";
                    $out = '/back/html/' . $this->name_url . '/custom/' . $_GET['method'] . '/' . $_GET['id'] . '/';
                }
                else
                    $out = '/back/html/' . $this->name_url . '/list/';
                break;
            case 'custom':
                if (empty($formvars))
                    die('no options for custom');
                $out = '/back/html/' . $this->name_url . '/custom/' . $formvars[0] . '/' . $formvars[1] . '/';
                break;
            case 'moduleExport':
                if (empty($formvars))
                    die('no options for custom');
                $out = '/back/html/' . $this->name_url . '/export/' . $formvars[0] . '/' . $params;
                break;
            case 'deleteItem':
                if (!empty($formvars['div'])) {
                    $div = 'div=' . $formvars['div'];
                    $params .= ( empty($params) ? '?' . $div : '&amp;' . $div );
                }
                if (!empty($formvars['refresh'])) {
                    $div = 'refresh=' . $formvars['refresh'];
                    $params .= ( empty($params) ? '?' . $div : '&amp;' . $div );
                }
                $out = '/back/html/' . $this->name_url . '/delete/' . $params;
                break;
            case 'export':
                $out = '/back/html/' . $this->name_url . '/list/' . $formvars['type'] . '/' . $params;
                break;
            default:
                die('no link for <b>' . $item . '</b>');
                break;
        }
        return $out;
    }

    function getValue($table, $champ, $select, $value) {

        $sql = "SELECT " . $champ;
        $sql.=" FROM " . $table;
        $sql.=" WHERE " . $select . " = '" . $value . "'";

        $this->sql->query($sql, SQL_INIT);
        return $this->sql->record[0];
    }

    function isDefault($table, $id) {
        $sql = "SELECT " . $table . "_default FROM " . $table . " WHERE " . $table . "_id = '" . $id . "'";

        $this->sql->query($sql, SQL_INIT);
        return $this->sql->record[0];
    }

    function setDefault($table, $table_base, $id, $default) {
        if (is_null($default))
            $zeID = $id;
        else
            $zeID = BackModule::getValue($table, $table_base . '_id', $table . '_id', $id);


        if ($default == 1) {
            // Si on met spefiquement cette ligne par default, on update tout a 0 et on la met a 1.
            $sql = "UPDATE " . $table . " SET " . $table . "_default = '0' WHERE " . $table_base . "_id = '" . $zeID . "'";
            $this->sql->query($sql);

            $sql = "UPDATE " . $table . " SET " . $table . "_default = '1' WHERE " . $table . "_id = '" . $id . "'";
            $this->sql->query($sql);
            //echo $sql;
        } else {
            // Si default est a 0 ou NULL, alors...
            //On regarde s'il existe une ligne par default
            $sql = "SELECT " . $table . "_id FROM " . $table . " WHERE " . $table_base . "_id = '" . $zeID . "' AND " . $table . "_default = '1'";

            $arrData = $this->sql->getAll($sql);

            if (empty($arrData)) {
                // Si non... on met la premiere ligne par defaut.
                $sql2 = "SELECT " . $table . "_id FROM " . $table . " WHERE " . $table_base . "_id = '" . $zeID . "'";

                $arrData = $this->sql->getAll($sql2);
                if (!empty($arrData)) {
                    // Si oui... alors on fait keud
                    $sql = "UPDATE " . $table . " SET " . $table . "_default = '1' WHERE " . $table . "_id = '" . $arrData[0][$table . "_id"] . "'";
                    $this->sql->query($sql);
                }
            }
        }

        if (is_null($default)) {
            // $default == NULL (delete)
            $sql = "SELECT " . $table . "_id FROM " . $table . " WHERE " . $table_base . "_id = '" . $id . "'";
            //echo $sql;
        } else {
            // (add/mod)
        }
    }

    function topdf($filename, $name, $options = "") {

        header('Content-Disposition: attachment; filename="' . $name . '.pdf"');
        header("Content-Type: application/pdf; charset=UTF-8");

        flush();
        passthru(HTMLDOC . " -t pdf --quiet --jpeg --webpage " . $options . " " . $filename);
    }

    function displayListGRAPH() {

        if (!$this->droits['READ']) {
            header('Location: /back/');
            exit;
            //exit;
        }
        $out = $this->displayPath();

        // SEARCH
        $isSearch = count($this->forms) > 0;
        if ($isSearch) {

            $js = "";
            $inputSearch = "";
            for ($i = 0; $i < count($this->forms); $i++) {
                if (isset($_GET[$this->forms[$i]->name]))
                    $inputSearch .= $this->forms[$i]->Displayform($_GET[$this->forms[$i]->name], $this);
                else
                    $inputSearch .= $this->forms[$i]->Displayform("", $this);
                if ($this->forms[$i]->value != '') {
                    $this->urlForms.=$this->forms[$i]->getUrl();
                    $this->sqlForms.=$this->forms[$i]->getSql();
                }
            }
        }

        // RECUPERATION DES RESULTATS

        $rows = $this->dataGraph;


        $searchClass = (($isSearch) ? "" : "off");



        $out .= "<div>";
        $out .= "<div class='table'>";
        //$out .= $search;
        // CONSTRUCTION DU GRAPH



        $records = "<table style='margin:0' id='records_top' class='records'>";
        $records .= "<tbody><tr><td class='table_controls'>";

        $records .="<div id='searchGraphList' class='records' style='width:20%;' >";
        $records .="<table style='border:1px solid #666;border-top:0' class='records'><tr><td>";
        $records .="<form id='form1' action='" . $this->getUrl() . "' name='form1' method='get'>";
        $records .="<input type='hidden' name='order' value='" . $this->orderBy . "' />";
        $records .="<table style='width:100%;height:586px;'><tr><td style='border:0'>";
        $records .="<fieldset class='searchList'>";
        $records .= $inputSearch;
        $records .="</fieldset></td>";
        $records .="</tr><tr><td valign='bottom' style='border:none;height:40px;vertical-align:bottom;padding-right:20px;'><p class='SubmitP'><input type='submit' value='Appliquer' /></p></td></tr></table></form></td></tr></table></div>";

        $records .="<div class='box' style='width:80%'>";

        $records .= $this->getGraph(1, "amline", "graph");

        $records .= "</div></td></tr></tbody>";
        $records .= "</table>";
        //-- CONSTRUCTION DE LA PAGINATION

        $out .= $records;


        $out .='<div class="records_view_options" style="height:28px"><dl>
		         <dt> Exporter : </dt>
		        <dd>
		          <ul>';
        $out .='<li class="pie_view_option_CSV"> <a id="f_pie_view_option" href="' . $this->link_to('export', array('type' => 'graphcsv')) . '"class="infobulle" title="Informations::Export du listing"> CSV </a></li>';
        $out .='</ul>
		        </dd>
		      </dl>
		    </div><div class="clear"></div>';

        $out .= "<div><table id='back_results' class='records'>";
        // AFFICHAGE DES EN-TETES
        $out .= "<thead>";
        $out .= "<tr>";
        $nbLabels = 1;
        foreach ($this->labels as $label) {
            $nbLabels++;
            $out .= $label->displayName($this);
        }
        $out .= "</tr>";
        $out .= "</thead>";
        // --
        // AFFICHAGE DES RESULTATS
        $out .= "<tbody>";
        $highlight = 0;

        $sum = array();

        $list = "";

        foreach ($rows as $row) {
            $highlight = abs(1 - ($highlight));

            $class = (($highlight) ? 'highlight' : '');

            $list .= "<tr id='" . $this->name_url . "_line_" . $row[0] . "' class='resultr $class'>";

//			if($this->droits['CONTEXT'] && ($this->droits['MOD'] || $this->droits['DEL']))
            //if($this->droits['CONTEXT'] && $this->droits['MOD'] && $row[0]!='no_context')
            //	$out .= "<td style='width:11px;padding:0.6em 0.3em;'><img style='cursor:pointer' alt='context_menu_btn' onmouseover=\"context_menu('".$this->link_to('contextMenu', array('id' => $row[0]))."',this); return false;\" src='".BACK_URL."styles/images/folder.gif' /></td>";
//if($row[0]=='no_context') $out .= "<td style='width:11px;padding:0.6em 0.3em;'></td>";
            //$out .= "<td style='width:11px;padding:0.6em 0.3em;'><img style='cursor:pointer' alt='context_menu_btn' onclick=\"context_menu('".$row[0]."','".$this->name_url."'); return false;\" src='".BACK_URL."styles/images/folder.gif' /></td>";

            $i = 1;

            foreach ($this->labels as $label) {

                $label->setVar('curID', $row[0]);
                $valOut = $label->displayData($this, $row[$i]);
                $list .= $valOut;
                if (!isset($sum[$i]))
                    $sum[$i] = 0;
                $sum[$i] = $sum[$i] + strip_tags($valOut);
                $i++;
            }

            $list .= "</tr>";
            $list .= "\n";
        }


        $out.='<tr>';
        $out.='<th class="text">CUMUL</th>';
        for ($i = 2; $i <= count($sum); $i++) {
            $out.='<th class="text">' . $sum[$i] . '</th>';
        }
        //<td class="text">320.24</td>
        $out.='</tr>';

        $out.=$list;

        $displayNoRows = ((count($rows) > 0) ? 'display:none;' : 'display:cell;' );

        $out .= "<tr><td id='noresultr' colspan='" . $nbLabels . "' style='" . $displayNoRows . "text-align:center;font-weight:bold;text-align:center;'>Aucun R&eacute;sultat</td></tr>";
        $out .= "</tbody>";
        //-- AFFICHAGE DES RESULTATS
        $out .= "</table></div>";

        $out .= "</div>";
        $out .= "</div>";

        //$out .= "<form id='ajax_form'><input name='ajax_obj' id='ajax_obj' type='text' value='".urlencode(gzencode(serialize($this)))."' /></form>";

        $out .= "<script type='text/javascript'>";
        $out .= $js;
        $out .= "</script>";

        return $out;
    }

    function displayListGRAPHCSV() {

        if (!$this->droits['EXP']) {
            $out = "ERROR 154 !!";
            return $out;
            exit;
        }

        $rows = $this->dataGraph;

        header('Content-Disposition: attachment; filename="export_' . $this->name_url . '_' . date('Y_m_d', time()) . '.csv"');
        header("Content-type: text/csv; charset=UTF-8");
        $out = "";
        foreach ($this->labels as $label) {
            $out .= '"' . utf8_decode($label->name) . '"';
            $out .= ";";
        }
        $out .= "\r\n";

        foreach ($rows as $row) {
            $i = 1;
            foreach ($this->labels as $label) {
                $out .= utf8_decode($row[$i]);
                $out .= ";";
                $i++;
            }
            $out .= "\r\n";
        }

        echo $out;
    }

    /**
     * @param $exportImport : 0 => export | 1 => import
     * @return string
     */
    function getHTMLExportImport($exportImport)
    {
        $out = '';

        $type = ($exportImport == 0) ? 'Export' : 'Import';
        $class = ($exportImport == 0) ? 'btn-info' : 'btn-default bg-orange';

        $sql = "SELECT * FROM back_module_export me, back_module m WHERE me.module_id=m.module_id AND module_page = '" . $this->name_url . "' AND module_export_import = ".$exportImport." ORDER BY module_export_rang";
        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
        $arrExport = $this->sql->record;

        if (!empty($arrExport)) {
            $out.= "<div class='btn-group margin-r-5'>";
            $out.= '<button type="button" class="btn btn-flat '.$class.' dropdown-toggle" data-toggle="dropdown" aria-expanded="false">
                    '.$type.'
                    <span class="caret"></span>
                    <span class="sr-only">Toggle Dropdown</span>
                    </button>';

            $out.= '<ul class="dropdown-menu">';

            foreach ($arrExport as $export) {
                if ($export['module_export_out'] == "ajax") {
                    $exportUrl = "ajax_form('" . $this->link_to('moduleExport', array($export['module_export_methode'])) . "')";
                } else {
                    $exportUrl = "document.location.href='" . $this->link_to('moduleExport', array($export['module_export_methode'])) . "'";
                }

                if (!empty($export['module_export_alert'])) {
                    $onclickAction = 'if(confirm(\'' . addslashes($export['module_export_alert']) . '\')) ' . $exportUrl . '; else return false;';
                } else {
                    $onclickAction = $exportUrl;
                }

                $out.= '<li><a title="' . $export['module_export_nom'] . '" data-toggle="tooltip" onclick="' . $onclickAction . '"><i class="'.$export['module_export_type'].'"></i> ' . $export['module_export_mini'] . ' </a></li>';
            }

            $out.= '</ul>';
            $out.= "</div>";
        }

        return $out;
    }

    /**
     * @param array  $formvars
     * @param string $table
     * @param int    $newId
     */
    protected function duplicateBoutique(
        array $formvars,
        string $table,
        int $newId
    ): void {
        $boutiqueTable = sprintf("%s_boutique", $table);
        $check = $this->sql->getOne(
            sprintf("SHOW TABLES LIKE '%s';", $boutiqueTable)
        );
        if ($check === null) {
            return;
        }

        $sql = sprintf(
            "INSERT INTO $boutiqueTable (%s_id, boutique_id, %s_boutique_statut_id)",
            $table,
            $table
        );
        $sql .= sprintf(
            " SELECT %d, boutique_id, %s_boutique_statut_id FROM %s",
            $newId,
            $table,
            $boutiqueTable
        );
        $sql .= sprintf(
            " WHERE 1 AND %s_id = %d",
            $table,
            $formvars['back_id']
        );

        $this->sql->query($sql);
    }

    /**
     * @param string $url
     * @param string $class
     * @return string
     */
    public function rendu($url = '', $class = '')
    {
        $out = '<button type="button" class=\'btn-flat btn btn-warning\' onclick="refreshIframeRendu(\'' . $class . '\');"><i class=\'fa fa-refresh\'></i>&nbsp;&nbsp;Actualisation</button>';
        $out .= '&nbsp;&nbsp;';
        $out .= '<a class=\'btn-flat btn btn-default\' href="' . $url . '" target="_blank"><i class=\'fa fa-link\'></i> Prévisualisation externe</a>';
        $out .= '<br/><br/>';
        $out .= "<iframe class='iframeRendu' onload='resizeIframe(this)' src='" . $url . "'></iframe>";

        return $out;
    }
}
