<?php

class bCms_block extends BackModule
{
    function update($formvars = array(), $table = null, $langue = true)
    {
        return parent::update_multi($formvars, $table, $langue);
    }

    function create($formvars = array(), $table = null, $langue = true)
    {
        $id = parent::create_multi($formvars, $table, $langue);
        return $id;
    }

    function delete($formvars = array())
    {
        return parent::delete_multi($formvars);
    }

    function Form($formvars = array())
    {

        if (empty($formvars['id'])) {
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('addForm') . "'>Ajout d'un nouveau bloc</a></span>";
        } else {
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('modForm', array('id' => $formvars['id'])) . "'>Edition du bloc : <strong>"
                . $formvars['id'] . "</strong></a></span>";
        }

        // SQL
        if (!empty($formvars['id'])) {
            $sql = "SELECT *";
            $sql .= " FROM cms_block cb";
            $sql .= " LEFT JOIN cms_block_nom cbn ON(cbn.cms_block_id = cb.cms_block_id AND cbn.langue_id = '" . LANGUE . "')";

            $sql .= " WHERE cb.cms_block_id = '" . $formvars['id'] . "'";

            $this->request = $sql;

            $sql = "SELECT * FROM cms_block cb WHERE cb.cms_block_id = '" . $formvars['id'] . "'";
            $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);
            $type = $this->sql->record['cms_block_type_id'];
        } else {
            $type = '';
        }
        //-- SQL
        //GROUP
        $form = new BackForm("Informations principales", "group");
        $this->addForm($form);
        //--GROUP
        // Champs du formulaire

        $form = new BackForm("Page ID", "hidden", "cms_page_id");
        $this->addForm($form);

        $form = new BackForm("Label", "text", "cms_block_nom_nom");
        $form->setVar('translate', true);
        $form->addAttr('class', 'required');
        $form->setVar('comment', 'Attention : Le label n\'apparaît pas en Front et sert uniquement pour l\'organisation des blocs en Back Office');
        $this->addForm($form);

        $form = new BackForm("Type", "select", "cms_block_type_id");
        $form->addAttr('class', 'required');
        $form->addOptionSQL(array(
            "SELECT cbt.cms_block_type_id, cbtn.cms_block_type_nom_nom 
            FROM cms_block_type cbt 
            LEFT JOIN cms_block_type_nom cbtn ON(cbt.cms_block_type_id = cbtn.cms_block_type_id AND cbtn.langue_id = '" . LANGUE . "') 
            WHERE cms_block_type_homepage = 0"
        ));
        $this->addForm($form);

        $form = new BackForm("Rang", "text", "cms_block_rang");
        $form->addAttr('class', 'required');
        $this->addForm($form);

        $form = new BackForm("Largeur", "select", "cms_block_width");
        $form->addAttr('class', 'required');
        $form->addOption(CmsBlock::WIDTH_33, "33%");
        $form->addOption(CmsBlock::WIDTH_50, "50%");
        $form->addOption(CmsBlock::WIDTH_66, "66%");
        $form->addOption(CmsBlock::WIDTH_100, "100%");
        $this->addForm($form);

        $form = new BackForm("Statut", "select", "cms_block_statut_id");
        $form->addOption(1, "ACTIF");
        $form->addOption(2, "INACTIF");
        $this->addForm($form);

        if ($type == CmsBlock::TYPE_IMAGE) {

            //GROUP
            $form = new BackForm("Contenu", "group");
            $this->addForm($form);
            //--GROUP

            $form = new BackForm("Fichier", "image", "cms_block_nom_image");
            $form->setVar('translate', true);
            $this->addForm($form);

            $form = new BackForm("Légence image", "text", "cms_block_nom_image_alt");
            $form->setVar('translate', true);
            $this->addForm($form);

            $form = new BackForm("URL", "text", "cms_block_nom_link_url");
            $form->setVar('translate', true);
            $this->addForm($form);

        }

        if ($type == CmsBlock::TYPE_TEXT) {

            //GROUP
            $form = new BackForm("Textes", "group");
            $this->addForm($form);
            //--GROUP

            $form = new BackForm("Titre", "text", "cms_block_nom_title");
            $form->setVar('translate', true);
            $this->addForm($form);

            $form = new BackForm("Contenu", "tinymce", "cms_block_nom_content");
            $form->setVar('translate', true);
            $this->addForm($form);

            //GROUP
            $form = new BackForm("Lien", "group");
            $this->addForm($form);
            //--GROUP

            $form = new BackForm("URL", "text", "cms_block_nom_link_url");
            $form->setVar('translate', true);
            $this->addForm($form);

            $form = new BackForm("Label", "text", "cms_block_nom_link_label");
            $form->setVar('translate', true);
            $this->addForm($form);
        }

        if ($type == CmsBlock::TYPE_BANNER) {

            //GROUP
            $form = new BackForm("Contenu", "group");
            $this->addForm($form);
            //--GROUP

            $form = new BackForm("URL Lien", "text", "cms_block_nom_link_url");
            $form->setVar('translate', true);
            $this->addForm($form);

            $form = new BackForm("Contenu", "textarea", "cms_block_nom_content");
            $form->setVar('translate', true);
            $this->addForm($form);

            //GROUP
            $form = new BackForm("Image", "group");
            $this->addForm($form);
            //--GROUP

            $form = new BackForm("Fichier Image", "image", "cms_block_nom_image");
            $form->setVar('translate', true);
            $this->addForm($form);

            $form = new BackForm("Balise ALT Image", "text", "cms_block_nom_image_alt");
            $form->setVar('translate', true);
            $this->addForm($form);
        }

        //-- Champs du formulaire
        if (!isset($formvars['id'])) {
            $formvars['id'] = 0;
        }

        return $this->displayForm($formvars['id']);
    }

    function Listing($formvars = array())
    {

        $sql = "SELECT cb.cms_block_id, cb.cms_block_id";
        $sql .= ", cbn.cms_block_nom_nom";
        $sql .= ", cbtn.cms_block_type_nom_nom";
        $sql .= ", CONCAT(FLOOR(cb.cms_block_width / 12 * 100), '%') as cms_block_width_percent";
        $sql .= ", cb.cms_block_rang";
        $sql .= ", cb.cms_block_statut_id";
        $sql .= " FROM (cms_block cb)";
        $sql .= " LEFT JOIN cms_block_nom cbn on (cbn.cms_block_id = cb.cms_block_id AND cbn.langue_id = '" . LANGUE . "')";
        $sql .= " LEFT JOIN cms_block_type cbt on (cbt.cms_block_type_id = cb.cms_block_type_id)";
        $sql .= " LEFT JOIN cms_block_type_nom cbtn on (cbtn.cms_block_type_id = cbt.cms_block_type_id AND cbtn.langue_id = '" . LANGUE . "')";

        $sql .= " WHERE 1";

        if (!empty($formvars['cms_page'])) {
            $sql .= " AND cb.cms_page_id = '" . $formvars['cms_page'] . "'";
        }

        $this->request = $sql;
        $this->orderBy = "cb.cms_block_rang ASC";
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("NOM");
        $this->addLabel($label);

        $label = new BackLabel("TYPE");
        $this->addLabel($label);

        $label = new BackLabel("WIDTH");
        $this->addLabel($label);

        $label = new BackLabel("RANG");
        $this->addLabel($label);

        $label = new BackLabel("STATUT", 'statut');
        $this->addLabel($label);

        //-- LABELS

        return $this->displayList($formvars['type']);
    }
}
