<?php

class bCms_page extends BackModule
{
    public function __construct($formvars = array())
    {
        parent::__construct($formvars);
        $GLOBALS['displayMceEditor'] = 1;
    }

    function update($formvars = array(), $table = null, $langue = true)
    {
        if (isset($formvars['parent_id']) && $formvars['parent_id'] == "NULL") {
            unset($formvars['parent_id']);
        }

        return parent::update_multi($formvars, $table, $langue);
    }

    function create($formvars = array(), $table = null, $langue = true)
    {
        if (isset($formvars['parent_id']) && $formvars['parent_id'] == "NULL") {
            unset($formvars['parent_id']);
        }

        if (empty($formvars['page_nom_url'])) {
            $formvars['page_nom_url'] = Tools::parseURL($formvars['page_nom_nom']);
        }

        $id = parent::create_multi($formvars, $table, $langue);
        Boutique::getInstance()->createStatut('cms_page', $id, 2);

        return $id;
    }

    function duplicate($formvars = array(), $table = null, $langue = true)
    {

        unset($formvars['page_nom_url']);

        $return = $this->create($formvars, $table, $langue);

        return $return;
    }

    function Form($formvars = array())
    {

        if (empty($formvars['id'])) {
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('addForm') . "'>Ajout d'une nouvelle Page</a></span>";
        } else {
            $sql = "SELECT page_nom_nom as data 
                    FROM cms_page_nom 
                    WHERE cms_page_id = '" . $formvars['id'] . "' 
                    AND langue_id = '" . LANGUE . "'";
            $this->sql->query($sql, SQL_ALL, SQL_ASSOC);
            $data = $this->sql->record[0];
            $this->path[] = "<span> &raquo; <a href='" . $this->link_to('modForm', array('id' => $formvars['id'])) . "'>Edition de la page : <strong>"
                . $data['data'] . "</strong></a></span>";
        }

        // SQL
        if (!empty($formvars['id'])) {
            $sql = "SELECT *";
            $sql .= " FROM cms_page p";
            $sql .= " LEFT JOIN cms_page_nom pn ON(pn.cms_page_id = p.cms_page_id AND pn.langue_id = '" . LANGUE . "')";

            $sql .= " WHERE p.cms_page_id='" . $formvars['id'] . "'";

            $this->request = $sql;

            $sql = "SELECT * FROM cms_page WHERE cms_page_id = '" . $formvars['id'] . "'";
            $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);
            $type = $this->sql->record['cms_page_type_id'];
        } else {
            $type = '';
        }
        //-- SQL
        //GROUP
        $form = new BackForm("Informations principales", "group");
        $this->addForm($form);
        //--GROUP
        // Champs du formulaire

        $form = new BackForm("Type", "select", "cms_page_type_id");
        $form->addAttr('class', 'required');
        $form->addOptionSQL(array(
            "SELECT cpt.cms_page_type_id, cptn.cms_page_type_nom_nom 
            FROM cms_page_type cpt 
            LEFT JOIN cms_page_type_nom cptn ON(cpt.cms_page_type_id = cptn.cms_page_type_id AND cptn.langue_id = '" . LANGUE . "')"
        ));
        $this->addForm($form);

        $form = new BackForm("Page Parent", "select", "parent_id");
        $form->addOption("NULL", "---");
        $form->addOptionSQL(array(
            "SELECT p.cms_page_id, pn.page_nom_nom 
            FROM cms_page p 
            LEFT JOIN cms_page_nom pn ON(p.cms_page_id = pn.cms_page_id AND pn.langue_id ='" . LANGUE . "')
            WHERE p.parent_id IS NULL AND p.cms_page_id != '" . ($formvars['id'] ?? '') . "' ORDER BY page_nom_nom",
            false
        ));
        $this->addForm($form);

        $form = new BackForm("Nom", "text", "page_nom_nom");
        $form->setVar('translate', true);
        $form->addAttr('class', 'required');
        $this->addForm($form);

        $form = new BackForm("Url", "text", "page_nom_url");
        $this->addForm($form);

        $form = new BackForm("Statut", "select", "page_statut_id");
        $form->addAttr('class', 'required');
        $form->addOptionSQL(array("SELECT page_statut_id, page_statut_nom FROM cms_page_statut"));
        $this->addForm($form);

        $form = new BackForm("Rang", "text", "page_rang");
        $form->addAttr('class', 'required');
        $this->addForm($form);

        if ($type == Cms::TYPE_STANDARD) {

            $form = new BackForm("Contenu", "tinymce", "page_nom_contenu");
            $form->setVar('translate', true);
            $this->addForm($form);
        }

        if ($type == Cms::TYPE_BLOCK) {
            $form = new BackForm("Blocks", "group");
            $form->addGroupOpts('class', 'cms_block');
            $this->addForm($form);
        }

        $form = new BackForm("Prévisualisation", "group");
        $form->addGroupOpts('class', 'cms_page_previsu');
        $this->addForm($form);

        $form = new BackForm("Boutiques", "group");
        $form->addGroupOpts('class', 'cms_page_boutique');
        $this->addForm($form);

        //-- Champs du formulaire
        if (!isset($formvars['id'])) {
            $formvars['id'] = 0;
        }

        return $this->displayForm($formvars['id']);
    }

    function Listing($formvars = array())
    {

        // RECHERCHE
        $form = new BackForm("Nom", "text", "pn.page_nom_nom");
        $form->setVar("compare", "LIKE");
        $this->addForm($form);

        $form = new BackForm("Position", "select", "mp.menu_position_id");
        $form->setVar("class_groupe", "col-xs-3");
        $form->addOption("", "---");
        $form->addOptionSQL(array("SELECT menu_position_id, menu_position_nom FROM cms_menu_position"));
        $this->addForm($form);

        $form = new BackForm("Menu", "select", "cpm.cms_menu_id");
        $form->setVar("class_groupe", "col-xs-3");
        $form->addOption("", "---");
        $form->addOptionSQL(array(
            "SELECT m.cms_menu_id, CONCAT(mn.menu_nom_nom, ' (', mp.menu_position_nom, ')')  
                                      FROM cms_menu m 
                                      LEFT JOIN cms_menu_nom mn ON(mn.cms_menu_id = m.cms_menu_id AND mn.langue_id = '" . LANGUE . "')
                                      LEFT JOIN cms_menu_position mp ON(mp.menu_position_id = m.menu_position_id)"
        ));
        $this->addForm($form);

        $form = new BackForm("Type", "select", "p.cms_page_type_id");
        $form->setVar("class_groupe", "col-xs-3");
        $form->addOption("", "---");
        $form->addOptionSQL(array(
            "SELECT cpt.cms_page_type_id, cptn.cms_page_type_nom_nom FROM cms_page_type cpt LEFT JOIN cms_page_type_nom cptn ON(cpt.cms_page_type_id = cptn.cms_page_type_id AND cptn.langue_id = '"
            . LANGUE . "')"
        ));
        $this->addForm($form);

        $form = new BackForm("Boutique", "select", "pb.boutique_id");
        $form->setVar("class_groupe", "col-xs-3");
        $form->addOption("", "---");
        $form->addOptionSQL(array("SELECT boutique_id, boutique_nom FROM boutique"));
        $this->addForm($form);
        //-- RECHERCHE

        $sql = "SELECT p.cms_page_id, p.cms_page_id";
        $sql .= ", pn.page_nom_nom";
        $sql .= ", ptn.cms_page_type_nom_nom";
        $sql .= ", mn.menu_nom_nom";
        $sql .= ", mp.menu_position_nom";
        $sql .= ", pn.page_nom_url";
        $sql .= ", p.page_rang";
        $sql .= ", CONCAT('<img src=\"/back/styles/images/actif', p.page_statut_id, '.png\" />')";
        $sql .= " FROM (cms_page p)";
        $sql .= " LEFT JOIN cms_page_nom pn on (pn.cms_page_id = p.cms_page_id)";
        $sql .= " LEFT JOIN cms_page pe on (pe.parent_id = p.cms_page_id)";
        $sql .= " LEFT JOIN cms_page_type pt on (pt.cms_page_type_id = p.cms_page_type_id)";
        $sql .= " LEFT JOIN cms_page_type_nom ptn on (ptn.cms_page_type_id = pt.cms_page_type_id AND ptn.langue_id = '" . LANGUE . "')";
        $sql .= " LEFT JOIN cms_menu_page cmp on (cmp.cms_page_id = p.cms_page_id)";
        $sql .= " LEFT JOIN cms_menu cm on (cm.cms_menu_id = cmp.cms_menu_id)";
        $sql .= " LEFT JOIN cms_menu_nom mn on (mn.cms_menu_id = cmp.cms_menu_id)";
        $sql .= " LEFT JOIN cms_menu_position mp on (cm.menu_position_id = mp.menu_position_id)";

        $sql .= "WHERE 1";
        if (!isset($_GET['p*parent_id']) || empty($_GET['p*parent_id']) || $_GET['p*parent_id'] == 'NULL') {
            $sql .= " AND p.parent_id IS NULL";
        }
        if (!empty($formvars['menu'])) {
            $sql .= " AND p.menu_id = '" . $formvars['menu'] . "'";
        }

        $this->request = $sql;
        //-- SQL
        // LABELS
        $label = new BackLabel("ID");
        $this->addLabel($label);

        $label = new BackLabel("NOM");
        $this->addLabel($label);

        $label = new BackLabel("TYPE");
        $this->addLabel($label);

        $label = new BackLabel("MENU");
        $this->addLabel($label);

        $label = new BackLabel("POSITION");
        $this->addLabel($label);

        $label = new BackLabel("URL");
        $this->addLabel($label);

        $label = new BackLabel("RANG");
        $this->addLabel($label);

        $label = new BackLabel("PUBLIE");
        $label->setVar('align', 'center');
        $this->addLabel($label);

        $label = new BackLabel("TRADUCTIONS", 'translate');
        $this->addLabel($label);

        //-- LABELS

        return $this->displayList($formvars['type']);
    }

    function autocomplete($formvars = array()) {
        $out = array();
        if (isset($formvars['q']) && !empty($formvars['q'])) {
            $cmsModel = new Cms();
            $arrArt = $cmsModel->getAutoComplete(array('search' => $formvars['q']));

            foreach ($arrArt as $arti) {
                $out[] = array(
                    'id' => $arti['cms_page_id'],
                    'text' => $this->formatTextAutocomplete($arti),
                );
            }

            if (!$out) {
                $out = array("Entrez le nom d'une page CMS");
            }
        } else {
            $out = array("Entrez le nom d'une page CMS");
        }

        return json_encode(array('results' => $out));
    }

    /**
     * Utile pour init le select lors de l'edition
     *
     * @param array $formvars
     * @return mixed
     * @throws Exception
     */
    function getAutocomplete($formvars = array()) {
        $cmsModel = new Cms();
        $results = $cmsModel->getAutoComplete(array('id' => $formvars['id']));

        return $this->formatTextAutocomplete($results[0]);
    }

    function formatTextAutocomplete($result)
    {
        return $result['page_nom_nom'];
    }
}
