<?php

use Phinx\Migration\AbstractMigration;

class InsertCmsBlockTypes extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $dataType = [
            [
                'cms_block_type_id'       => 1,
                'cms_block_type_template' => 'blocks/block_banner.tpl'
            ],
            [
                'cms_block_type_id'       => 2,
                'cms_block_type_template' => 'blocks/block_image.tpl'
            ],
            [
                'cms_block_type_id'       => 3,
                'cms_block_type_template' => 'blocks/block_text.tpl'
            ]
        ];

        $this->table('cms_block_type')->insert($dataType)->update();

        $dataTypeNom = [
            [
                'cms_block_type_id'      => 1,
                'langue_id'              => 1,
                'cms_block_type_nom_nom' => 'Bannière'
            ],
            [
                'cms_block_type_id'      => 2,
                'langue_id'              => 1,
                'cms_block_type_nom_nom' => 'Image'
            ],
            [
                'cms_block_type_id'      => 3,
                'langue_id'              => 1,
                'cms_block_type_nom_nom' => 'Texte'
            ]
        ];

        $this->table('cms_block_type_nom')->insert($dataTypeNom)->update();
    }
}
