<?php

use Phinx\Db\Adapter\MysqlAdapter;
use Phinx\Migration\AbstractMigration;

class FixStatutColumns extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $this->table('cms_block')->removeColumn('cms_block_statut')->addColumn('cms_block_statut_id', 'integer', ['default' => 1, 'limit' => MysqlAdapter::INT_TINY])->update();
        $this->table('cms_page_type')->removeColumn('cms_page_type_status')->addColumn('cms_page_type_statut_id', 'integer', ['default' => 1, 'limit' => MysqlAdapter::INT_TINY])->update();
    }
}
