<?php

use Phinx\Migration\AbstractMigration;

class CleanCmsPage extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $this->table('cms_page')->dropForeignKey('cms_menu_id')->update();
        $this->table('cms_page')->dropForeignKey('alias_id')->update();
        $this->table('cms_page')->removeColumn('cms_menu_id')->update();
        $this->table('cms_page')->removeColumn('alias_id')->update();

        $this->table('cms_menu_page', ['id' => false, 'primary_key' => ['cms_menu_page_id']])
             ->addColumn('cms_menu_page_id', 'integer', ['identity' => 'enable', 'signed' => false])
             ->addColumn('cms_page_id', 'integer', ['signed' => false])
             ->addColumn('cms_menu_id', 'integer', ['signed' => false])
             ->addForeignKey('cms_page_id', 'cms_page', 'cms_page_id', ['delete' => 'CASCADE', 'update' => 'CASCADE'])
             ->addForeignKey('cms_menu_id', 'cms_menu', 'cms_menu_id', ['delete' => 'CASCADE', 'update' => 'CASCADE'])
             ->addIndex(['cms_page_id', 'cms_menu_id'], ['unique' => true])
             ->create();
    }
}
