<?php

use Phinx\Db\Adapter\MysqlAdapter;
use Phinx\Migration\AbstractMigration;

class AddBlockTypeHomepageLogic extends AbstractMigration
{
    /**
     * Change Method.
     *
     * Write your reversible migrations using this method.
     *
     * More information on writing migrations is available here:
     * http://docs.phinx.org/en/latest/migrations.html#the-abstractmigration-class
     *
     * The following commands can be used in this method and Phinx will
     * automatically reverse them when rolling back:
     *
     *    createTable
     *    renameTable
     *    addColumn
     *    renameColumn
     *    addIndex
     *    addForeignKey
     *
     * Remember to call "create()" or "update()" and NOT "save()" when working
     * with the Table class.
     */
    public function change()
    {
        $this->table('cms_block_type')->addColumn('cms_block_type_homepage', 'integer', ['limit' => MysqlAdapter::INT_TINY])->update();

        $dataType = [
            [
                'cms_block_type_id'       => 4,
                'cms_block_type_template' => 'homepage/block_banner.tpl',
                'cms_block_type_homepage' => 1
            ],
            [
                'cms_block_type_id'       => 5,
                'cms_block_type_template' => 'homepage/block_image.tpl',
                'cms_block_type_homepage' => 1
            ],
            [
                'cms_block_type_id'       => 6,
                'cms_block_type_template' => 'homepage/block_text.tpl',
                'cms_block_type_homepage' => 1
            ]
        ];

        $this->table('cms_block_type')->insert($dataType)->update();

        $dataTypeNom = [
            [
                'cms_block_type_id'      => 4,
                'langue_id'              => 1,
                'cms_block_type_nom_nom' => 'Bannière'
            ],
            [
                'cms_block_type_id'      => 5,
                'langue_id'              => 1,
                'cms_block_type_nom_nom' => 'Image'
            ],
            [
                'cms_block_type_id'      => 6,
                'langue_id'              => 1,
                'cms_block_type_nom_nom' => 'Texte'
            ]
        ];

        $this->table('cms_block_type_nom')->insert($dataTypeNom)->update();
    }
}
