<?php

/**
 * Class Cms
 */
class Cms extends Model
{

    const POSITION_FOOTER  = 1;
    const POSITION_HEADER  = 2;
    const POSITION_LINKS   = 3;
    const POSITION_CREDITS = 4;

    const M_FOOTER  = 1;
    const M_CREDITS = 2;

    const TYPE_STANDARD = 1;
    const TYPE_BLOCK    = 2;

    protected $table = "cms_page";

    /**
     * @param array $formvars
     *
     * @return array
     * @throws DediException
     */
    public function getOne($formvars = array())
    {
        $result = $this->get($formvars);

        return (!empty($result)) ? $result[0] : null;
    }

    /**
     * @param array $formvars
     * @param string $champs
     * @return null
     * @throws DediException
     */
    public function get($formvars = array(), $champs = "")
    {

        $boutiqueId = Boutique::getInstance()->id;
        $langueId   = Boutique::getInstance()->getLangue()->id;


        $sql = "SELECT *";
        $sql .= " FROM cms_page cp";
        $sql .= " LEFT JOIN cms_page_nom cpn ON(cpn.cms_page_id = cp.cms_page_id AND cpn.langue_id = '" . $langueId . "')";
        $sql .= " LEFT JOIN cms_page_type cpt ON(cpt.cms_page_type_id = cp.cms_page_type_id)";
        $sql .= " LEFT JOIN cms_page_type_nom cptn ON(cptn.cms_page_type_id = cpt.cms_page_type_id AND cptn.langue_id = '" . $langueId . "')";

        if (empty($formvars['no_boutique'])) {
            $sql .= " INNER JOIN cms_page_boutique cpb ON (cp.cms_page_id = cpb.cms_page_id AND cpb.boutique_id = '" . $boutiqueId . "')";
        }
        $sql .= " WHERE 1";

        if (!empty($formvars['page_statut_id'])) {
            $sql .= " AND cp.page_statut_id = '" . $formvars['page_statut_id'] . "'";
        } elseif (empty($formvars['all'])) {
            $sql .= " AND cp.page_statut_id = 1";
        }

        if (empty($formvars['all'])) {
            $sql .= " AND cpb.cms_page_boutique_statut_id = '1'";
        }

        if (!empty($formvars['cms_page_id'])) {
            $sql .= " AND cp.cms_page_id = '" . $formvars['cms_page_id'] . "'";
        }

        if (!empty($formvars['page_nom_url'])) {
            $sql .= " AND cpn.page_nom_url = '" . $formvars['page_nom_url'] . "'";
        }

        $sql .= " ORDER BY page_rang";

        if (empty($champs)) {
            $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);
            $data = $this->sql->record;

            return $data;
        } else {
            $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);

            return $this->sql->record[$champs];
        }
    }

    /**
     * @param array $formvars
     * @param string $champs
     * @return array|null
     * @throws DediException
     */
    public function getPosition($formvars = array(), $champs = "")
    {

        $sql = "SELECT *";
        $sql .= " FROM (cms_menu m)";
        $sql .= " INNER JOIN cms_menu_nom mn ON (m.cms_menu_id = mn.cms_menu_id AND mn.langue_id = '" . Boutique::getInstance()->getLangue()->id . "')";
        if (empty($formvars['no_boutique'])) {
            $sql .= " INNER JOIN cms_menu_boutique cmb ON (m.cms_menu_id = cmb.cms_menu_id AND cmb.boutique_id = '" . Boutique::getInstance()->id . "')";
        }
        $sql .= " WHERE 1";
        $sql .= " AND m.menu_statut_id = 1";

        if (empty($formvars['no_boutique'])) {
            $sql .= " AND cmb.cms_menu_boutique_statut_id = '1'";
        }

        if (!empty($formvars['cms_menu_id'])) {
            $sql .= " AND m.cms_menu_id = '" . $formvars['cms_menu_id'] . "'";
        }
        if (!empty($formvars['menu_position_id'])) {
            $sql .= " AND m.menu_position_id = '" . $formvars['menu_position_id'] . "'";
        }
        if (!empty($formvars['menu_nom_url'])) {
            $sql .= " AND mn.menu_nom_url = '" . $formvars['menu_nom_url'] . "'";
        }

        $sql .= " ORDER BY menu_rang";

        if (empty($champs)) {
            $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);

            return $this->sql->record;
        } else {
            $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);

            return $this->sql->record[$champs];
        }
    }

    /**
     * @param array $formvars
     * @param string $champs
     * @return array|null
     * @throws DediException
     */
    public function getMenu($formvars = array(), $champs = "")
    {

        $sql = " SELECT *";
        $sql .= " FROM (cms_page p)";
        $sql .= " LEFT JOIN cms_page_nom pn ON (p.cms_page_id = pn.cms_page_id AND pn.langue_id = '" . Boutique::getInstance()->getLangue()->id . "')";
        $sql .= " INNER JOIN cms_menu_page cmp ON(p.cms_page_id = cmp.cms_page_id)";

        if (empty($formvars['no_boutique'])) {
            $sql .= " INNER JOIN cms_page_boutique cpb ON (p.cms_page_id = cpb.cms_page_id AND cpb.boutique_id = '" . Boutique::getInstance()->id . "')";
        }
        $sql .= " WHERE 1";

        $sql .= " AND p.page_statut_id = 1";

        if (empty($formvars['no_boutique'])) {
            $sql .= " AND cpb.cms_page_boutique_statut_id = '1'";
        }

        if (!empty($formvars['menu_position_id'])) {
            $sql .= " AND cmp.cms_menu_id = '" . $formvars['menu_position_id'] . "'";
        }

        if (!empty($formvars['page_nom_url'])) {
            $sql .= " AND pn.page_nom_url = '" . $formvars['page_nom_url'] . "'";
        }
        if (!empty($formvars['parent_id'])) {
            $sql .= " AND p.parent_id = '" . $formvars['parent_id'] . "'";
        }

        $sql .= " ORDER BY p.page_rang";

        if (empty($champs)) {
            $this->sql->query($sql, SiteSQL::SQL_ALL, SiteSQL::SQL_ASSOC);

            return $this->sql->record;
        } else {
            $this->sql->query($sql, SiteSQL::SQL_INIT, SiteSQL::SQL_ASSOC);

            return $this->sql->record[$champs];
        }
    }

    /**
     * @param array $formvars
     * @return array|null
     * @throws DediException
     */
    public function getAutoComplete($formvars = array())
    {

        if (empty($formvars['id']) && mb_strlen($formvars['search']) < 2) {
            return array();
        }

        $sql = "SELECT cpn.cms_page_id, cpn.page_nom_nom";
        $sql .= " FROM cms_page_nom cpn";
        $sql .= " WHERE 1";

        if (!empty($formvars['id'])) {
            $sql .= " AND cpn.cms_page_id = '" . $formvars['id'] . "'";
        }

        if (!empty($formvars['search'])) {
            $sql .= " AND (cpn.page_nom_nom LIKE '%" . $formvars['search'] . "%'";
            $sql .= " OR cpn.cms_page_id LIKE '%" . $formvars['search'] . "%'
            )";
        }
        $sql .= " GROUP BY cpn.cms_page_nom_id";
        $this->sql->query($sql, SQL_ALL, SQL_ASSOC);

        return $this->sql->record;
    }
}
