<?php

/**
 * Class CmsBlock
 */
class CmsBlock extends Model
{
    const TYPE_BANNER          = 1;
    const TYPE_IMAGE           = 2;
    const TYPE_TEXT            = 3;
    const TYPE_HOMEPAGE_BANNER = 4;
    const TYPE_HOMEPAGE_IMAGE  = 5;
    const TYPE_HOMEPAGE_TEXT   = 6;

    const WIDTH_33  = 4;
    const WIDTH_50  = 6;
    const WIDTH_66  = 8;
    const WIDTH_100 = 12;

    protected $table = "cms_block";

    /**
     * CmsBlock constructor.
     * @param null $id
     * @throws Exception
     */
    public function __construct($id = null)
    {
        $this->leftJoin[]      = array('cms_block_type', 'cbt.cms_block_type_id', 'cb.cms_block_type_id');
        $this->extras['order'] = 'cb.cms_block_rang ASC';
        parent::__construct($id);
    }

    /**
     * @param array $formvars
     *
     * @return array
     */
    public function getOne($formvars = array())
    {
        $result = $this->get($formvars);

        return (!empty($result)) ? $result[0] : null;
    }

    public function get($formvars = array())
    {
        if (!isset($formvars['cms_block_statut_id'])) {
            $formvars['cms_block_statut_id'] = 1;
        }

        return parent::get($formvars);
    }
}
