<?php

namespace Controller;

use Ads;
use Listing;
use Categorie;
use CmsBlock;
use Symfony\Component\HttpFoundation\RedirectResponse;
use Symfony\Component\Routing\Annotation\Route;

/**
 * Class HomeController
 * @package Controller
 */
class HomeController extends Controller
{
    /**
     * @Route(path = "/", name="home", options={"_sitemap" = {"changefreq" = "daily", "priority" = 0.8}})
     *
     * @return \Symfony\Component\HttpFoundation\Response
     */
    public function show()
    {
        $pub = new Ads;
        $arrAds = $pub->get(['limit' => 8, 'order' => 'a.ads_rang ASC', 'ae.ads_emplacement_id' => Ads::SLIDESHOW_HOME]);
        $this->template->assign('slideshows', $arrAds);

        $this->template->assign('home', true);

        $cmsBlockModel = new CmsBlock();
        $homepageBlocks = $cmsBlockModel->get(['cms_block_homepage' => true]);
        $this->template->assign('homepageBlocks', $homepageBlocks);

        return $this->render('index.tpl');
    }

}
